Type: Package
Package: ggcorrplot
Title: Visualization of a Correlation Matrix using 'ggplot2'
Version: 0.2.0
Date: 2026-07-08
Authors@R: 
    c(person(given = "Alboukadel",
             family = "Kassambara",
             role = c("aut", "cre"),
             email = "alboukadel.kassambara@gmail.com"),
      person(given = "Indrajeet",
             family = "Patil",
             role = "ctb",
             email = "patilindrajeet.science@gmail.com",
             comment = c(ORCID = "0000-0003-1995-6531", Twitter = "@patilindrajeets")))
Description: The 'ggcorrplot' package can be used to visualize easily a
    correlation matrix using 'ggplot2'. It provides a solution for
    reordering the correlation matrix and displays the significance level
    on the plot. It also includes a function for computing a matrix of
    correlation p-values.
License: GPL-2
URL:
        https://www.sthda.com/english/wiki/ggcorrplot-visualization-of-a-correlation-matrix-using-ggplot2
BugReports: https://github.com/kassambara/ggcorrplot/issues
Depends: R (>= 3.3), ggplot2 (>= 3.3.6)
Imports: reshape2, stats
Suggests: testthat (>= 3.0.0), knitr, spelling, vdiffr (>= 1.0.0)
Encoding: UTF-8
Language: en-US
RoxygenNote: 7.1.0
Config/testthat/edition: 3
NeedsCompilation: no
Packaged: 2026-07-08 15:18:07 UTC; kassambara
Author: Alboukadel Kassambara [aut, cre],
  Indrajeet Patil [ctb] (ORCID: <https://orcid.org/0000-0003-1995-6531>,
    Twitter: @patilindrajeets)
Maintainer: Alboukadel Kassambara <alboukadel.kassambara@gmail.com>
Repository: CRAN
Date/Publication: 2026-07-08 16:00:02 UTC

Type: Package
Package: ggcorrplot
Title: Visualization of a Correlation Matrix using 'ggplot2'
Version: 0.1.4.1
Authors@R: 
    c(person(given = "Alboukadel",
             family = "Kassambara",
             role = c("aut", "cre"),
             email = "alboukadel.kassambara@gmail.com"),
      person(given = "Indrajeet",
             family = "Patil",
             role = "ctb",
             email = "patilindrajeet.science@gmail.com",
             comment = c(ORCID = "0000-0003-1995-6531", Twitter = "@patilindrajeets")))
Description: The 'ggcorrplot' package can be used to visualize easily a
    correlation matrix using 'ggplot2'. It provides a solution for
    reordering the correlation matrix and displays the significance level
    on the plot. It also includes a function for computing a matrix of
    correlation p-values.
License: GPL-2
URL:
        http://www.sthda.com/english/wiki/ggcorrplot-visualization-of-a-correlation-matrix-using-ggplot2
BugReports: https://github.com/kassambara/ggcorrplot/issues
Depends: R (>= 3.3), ggplot2 (>= 3.3.6)
Imports: reshape2, stats
Suggests: testthat (>= 3.0.0), knitr, spelling, vdiffr (>= 1.0.0)
Encoding: UTF-8
Language: en-US
RoxygenNote: 7.1.0
Config/testthat/edition: 3
NeedsCompilation: no
Packaged: 2023-09-05 15:45:33 UTC; hornik
Author: Alboukadel Kassambara [aut, cre],
  Indrajeet Patil [ctb] (<https://orcid.org/0000-0003-1995-6531>,
    @patilindrajeets)
Maintainer: Alboukadel Kassambara <alboukadel.kassambara@gmail.com>
Repository: CRAN
Date/Publication: 2023-09-05 15:50:48 UTC
Built: R 4.6.0; ; 2026-04-27 23:42:31 UTC; unix

<!-- README.md is generated from README.Rmd. Please edit that file -->

[![R build
status](https://github.com/kassambara/ggcorrplot/workflows/R-CMD-check/badge.svg)](https://github.com/kassambara/ggcorrplot/actions)
[![CRAN\_Status\_Badge](https://www.r-pkg.org/badges/version/ggcorrplot)](https://cran.r-project.org/package=ggcorrplot)
[![CRAN
Checks](https://badges.cranchecks.info/summary/ggcorrplot.svg)](https://cran.r-project.org/web/checks/check_results_ggcorrplot.html)
[![Downloads](https://cranlogs.r-pkg.org/badges/ggcorrplot)](https://cran.r-project.org/package=ggcorrplot)
[![Total
Downloads](https://cranlogs.r-pkg.org/badges/grand-total/ggcorrplot?color=orange)](https://cranlogs.r-pkg.org/badges/grand-total/ggcorrplot)

# ggcorrplot: Visualization of a correlation matrix using ggplot2

The **ggcorrplot** package can be used to **visualize easily** a
**correlation matrix** using **ggplot2**. It provides a solution for
**reordering** the correlation matrix and displays the **significance
level** on the correlogram. It includes also a function for computing a
matrix of **correlation p-values**.

Find out more at
<https://www.sthda.com/english/wiki/ggcorrplot-visualization-of-a-correlation-matrix-using-ggplot2>.

## Installation and loading

ggcorrplot can be installed from `CRAN` as follow:

``` r
install.packages("ggcorrplot")
```

Or, install the latest version from GitHub:

``` r
# Install
if(!require(devtools)) install.packages("devtools")
devtools::install_github("kassambara/ggcorrplot")
```

``` r
# Loading
library(ggcorrplot)
```

## Getting started

### Compute a correlation matrix

The *mtcars* data set will be used in the following R code. The function
**cor\_pmat()** \[in **ggcorrplot**\] computes a matrix of correlation
p-values.

``` r
# Compute a correlation matrix
data(mtcars)
corr <- round(cor(mtcars), 1)
head(corr[, 1:6])
#>       mpg  cyl disp   hp drat   wt
#> mpg   1.0 -0.9 -0.8 -0.8  0.7 -0.9
#> cyl  -0.9  1.0  0.9  0.8 -0.7  0.8
#> disp -0.8  0.9  1.0  0.8 -0.7  0.9
#> hp   -0.8  0.8  0.8  1.0 -0.4  0.7
#> drat  0.7 -0.7 -0.7 -0.4  1.0 -0.7
#> wt   -0.9  0.8  0.9  0.7 -0.7  1.0

# Compute a matrix of correlation p-values
p.mat <- cor_pmat(mtcars)
head(p.mat[, 1:4])
#>               mpg          cyl         disp           hp
#> mpg  0.000000e+00 6.112687e-10 9.380327e-10 1.787835e-07
#> cyl  6.112687e-10 0.000000e+00 1.802838e-12 3.477861e-09
#> disp 9.380327e-10 1.802838e-12 0.000000e+00 7.142679e-08
#> hp   1.787835e-07 3.477861e-09 7.142679e-08 0.000000e+00
#> drat 1.776240e-05 8.244636e-06 5.282022e-06 9.988772e-03
#> wt   1.293959e-10 1.217567e-07 1.222320e-11 4.145827e-05
```

## Correlation matrix visualization

``` r
# Visualize the correlation matrix
# --------------------------------
# method = "square" (default)
ggcorrplot(corr)
```

![ggcorrplot: visualize correlation matrix using
ggplot2](tools/README-demo-ggcorrplot-1.png)

``` r
# method = "circle"
ggcorrplot(corr, method = "circle")
#> Warning: `guides(<scale> = FALSE)` is deprecated. Please use `guides(<scale> =
#> "none")` instead.
```

![ggcorrplot: visualize correlation matrix using
ggplot2](tools/README-demo-ggcorrplot-2.png)

``` r

# Reordering the correlation matrix
# --------------------------------
# using hierarchical clustering
ggcorrplot(corr, hc.order = TRUE, outline.color = "white")
```

![ggcorrplot: visualize correlation matrix using
ggplot2](tools/README-demo-ggcorrplot-3.png)

``` r

# Types of correlogram layout
# --------------------------------
# Get the lower triangle
ggcorrplot(corr,
           hc.order = TRUE,
           type = "lower",
           outline.color = "white")
```

![ggcorrplot: visualize correlation matrix using
ggplot2](tools/README-demo-ggcorrplot-4.png)

``` r

# Get the upper triangle
ggcorrplot(corr,
           hc.order = TRUE,
           type = "upper",
           outline.color = "white")
```

![ggcorrplot: visualize correlation matrix using
ggplot2](tools/README-demo-ggcorrplot-5.png)

``` r

# Change colors and theme
# --------------------------------
# Argument colors
ggcorrplot(
  corr,
  hc.order = TRUE,
  type = "lower",
  outline.color = "white",
  ggtheme = ggplot2::theme_gray,
  colors = c("#6D9EC1", "white", "#E46726")
)
```

![ggcorrplot: visualize correlation matrix using
ggplot2](tools/README-demo-ggcorrplot-6.png)

``` r

# Add correlation coefficients
# --------------------------------
# argument lab = TRUE
ggcorrplot(corr,
           hc.order = TRUE,
           type = "lower",
           lab = TRUE)
```

![ggcorrplot: visualize correlation matrix using
ggplot2](tools/README-demo-ggcorrplot-7.png)

``` r

# Add correlation significance level
# --------------------------------
# Argument p.mat
# Barring the no significant coefficient
ggcorrplot(corr,
           hc.order = TRUE,
           type = "lower",
           p.mat = p.mat)
```

![ggcorrplot: visualize correlation matrix using
ggplot2](tools/README-demo-ggcorrplot-8.png)

``` r

# Leave blank on no significant coefficient
ggcorrplot(
  corr,
  p.mat = p.mat,
  hc.order = TRUE,
  type = "lower",
  insig = "blank"
)
```

![ggcorrplot: visualize correlation matrix using
ggplot2](tools/README-demo-ggcorrplot-9.png)

<!-- README.md is generated from README.Rmd. Please edit that file -->

[![R build
status](https://github.com/kassambara/ggcorrplot/workflows/R-CMD-check/badge.svg)](https://github.com/kassambara/ggcorrplot/actions)
[![CRAN\_Status\_Badge](https://www.r-pkg.org/badges/version/ggcorrplot)](https://cran.r-project.org/package=ggcorrplot)
[![CRAN
Checks](https://cranchecks.info/badges/summary/ggcorrplot)](https://cran.r-project.org/web/checks/check_results_ggcorrplot.html)
[![Downloads](https://cranlogs.r-pkg.org/badges/ggcorrplot)](https://cran.r-project.org/package=ggcorrplot)
[![Total
Downloads](https://cranlogs.r-pkg.org/badges/grand-total/ggcorrplot?color=orange)](https://cranlogs.r-pkg.org/badges/grand-total/ggcorrplot)

# ggcorrplot: Visualization of a correlation matrix using ggplot2

The **ggcorrplot** package can be used to **visualize easily** a
**correlation matrix** using **ggplot2**. It provides a solution for
**reordering** the correlation matrix and displays the **significance
level** on the correlogram. It includes also a function for computing a
matrix of **correlation p-values**.

Find out more at
<http://www.sthda.com/english/wiki/ggcorrplot-visualization-of-a-correlation-matrix-using-ggplot2>.

## Installation and loading

ggcorrplot can be installed from `CRAN` as follow:

``` r
install.packages("ggcorrplot")
```

Or, install the latest version from GitHub:

``` r
# Install
if(!require(devtools)) install.packages("devtools")
devtools::install_github("kassambara/ggcorrplot")
```

``` r
# Loading
library(ggcorrplot)
```

## Getting started

### Compute a correlation matrix

The *mtcars* data set will be used in the following R code. The function
**cor\_pmat()** \[in **ggcorrplot**\] computes a matrix of correlation
p-values.

``` r
# Compute a correlation matrix
data(mtcars)
corr <- round(cor(mtcars), 1)
head(corr[, 1:6])
#>       mpg  cyl disp   hp drat   wt
#> mpg   1.0 -0.9 -0.8 -0.8  0.7 -0.9
#> cyl  -0.9  1.0  0.9  0.8 -0.7  0.8
#> disp -0.8  0.9  1.0  0.8 -0.7  0.9
#> hp   -0.8  0.8  0.8  1.0 -0.4  0.7
#> drat  0.7 -0.7 -0.7 -0.4  1.0 -0.7
#> wt   -0.9  0.8  0.9  0.7 -0.7  1.0

# Compute a matrix of correlation p-values
p.mat <- cor_pmat(mtcars)
head(p.mat[, 1:4])
#>               mpg          cyl         disp           hp
#> mpg  0.000000e+00 6.112687e-10 9.380327e-10 1.787835e-07
#> cyl  6.112687e-10 0.000000e+00 1.802838e-12 3.477861e-09
#> disp 9.380327e-10 1.802838e-12 0.000000e+00 7.142679e-08
#> hp   1.787835e-07 3.477861e-09 7.142679e-08 0.000000e+00
#> drat 1.776240e-05 8.244636e-06 5.282022e-06 9.988772e-03
#> wt   1.293959e-10 1.217567e-07 1.222320e-11 4.145827e-05
```

## Correlation matrix visualization

``` r
# Visualize the correlation matrix
# --------------------------------
# method = "square" (default)
ggcorrplot(corr)
```

![ggcorrplot: visualize correlation matrix using
ggplot2](tools/README-demo-ggcorrplot-1.png)

``` r
# method = "circle"
ggcorrplot(corr, method = "circle")
#> Warning: `guides(<scale> = FALSE)` is deprecated. Please use `guides(<scale> =
#> "none")` instead.
```

![ggcorrplot: visualize correlation matrix using
ggplot2](tools/README-demo-ggcorrplot-2.png)

``` r

# Reordering the correlation matrix
# --------------------------------
# using hierarchical clustering
ggcorrplot(corr, hc.order = TRUE, outline.color = "white")
```

![ggcorrplot: visualize correlation matrix using
ggplot2](tools/README-demo-ggcorrplot-3.png)

``` r

# Types of correlogram layout
# --------------------------------
# Get the lower triangle
ggcorrplot(corr,
           hc.order = TRUE,
           type = "lower",
           outline.color = "white")
```

![ggcorrplot: visualize correlation matrix using
ggplot2](tools/README-demo-ggcorrplot-4.png)

``` r

# Get the upper triangle
ggcorrplot(corr,
           hc.order = TRUE,
           type = "upper",
           outline.color = "white")
```

![ggcorrplot: visualize correlation matrix using
ggplot2](tools/README-demo-ggcorrplot-5.png)

``` r

# Change colors and theme
# --------------------------------
# Argument colors
ggcorrplot(
  corr,
  hc.order = TRUE,
  type = "lower",
  outline.color = "white",
  ggtheme = ggplot2::theme_gray,
  colors = c("#6D9EC1", "white", "#E46726")
)
```

![ggcorrplot: visualize correlation matrix using
ggplot2](tools/README-demo-ggcorrplot-6.png)

``` r

# Add correlation coefficients
# --------------------------------
# argument lab = TRUE
ggcorrplot(corr,
           hc.order = TRUE,
           type = "lower",
           lab = TRUE)
```

![ggcorrplot: visualize correlation matrix using
ggplot2](tools/README-demo-ggcorrplot-7.png)

``` r

# Add correlation significance level
# --------------------------------
# Argument p.mat
# Barring the no significant coefficient
ggcorrplot(corr,
           hc.order = TRUE,
           type = "lower",
           p.mat = p.mat)
```

![ggcorrplot: visualize correlation matrix using
ggplot2](tools/README-demo-ggcorrplot-8.png)

``` r

# Leave blank on no significant coefficient
ggcorrplot(
  corr,
  p.mat = p.mat,
  hc.order = TRUE,
  type = "lower",
  insig = "blank"
)
```

![ggcorrplot: visualize correlation matrix using
ggplot2](tools/README-demo-ggcorrplot-9.png)

#' Visualization of a correlation matrix using ggplot2
#' @import ggplot2
#' @importFrom grDevices col2rgb rgb
#' @description \itemize{ \item ggcorrplot(): A graphical display of a
#'   correlation matrix using ggplot2. The main plot options are walked through in
#'   \href{https://www.datanovia.com/learn/biostatistics/correlation/ggcorrplot-in-r}{ggcorrplot:
#'   Correlation Matrix Heatmap in R with ggplot2}. \item cor_pmat(): Compute a
#'   correlation matrix p-values, to mark the significant cells. A worked
#'   example is in
#'   \href{https://www.datanovia.com/learn/biostatistics/correlation/ggcorrplot-in-r}{ggcorrplot:
#'   Correlation Matrix Heatmap in R with ggplot2}. }
#' @param corr the correlation matrix to visualize
#' @param method character, the visualization method of correlation matrix to be
#'   used. Allowed values are "square" (default), "circle".
#' @param scale.square logical. If \code{TRUE} and \code{method = "square"}, the
#'   squares are sized by the absolute correlation (larger square = stronger
#'   correlation), in addition to the fill color -- the classic corrplot
#'   size-scaled square look. Defaults to \code{FALSE} (constant full-cell
#'   squares, the current behavior). Has no effect for \code{method = "circle"}
#'   (circles are always sized). Uses \code{circle.scale} to tune the size range.
#'   As with \code{method = "circle"}, coefficient labels (\code{lab = TRUE}) are
#'   drawn at full size and may overflow the smallest squares.
#' @param cell.grid logical. If \code{TRUE}, draw a light rectangle around every
#'   cell (behind the glyphs) and remove the through-center gridlines, so the
#'   sized glyphs (\code{method = "circle"} or \code{scale.square = TRUE}) sit
#'   inside boxed cells -- the corrplot boxed-cell look. Defaults to \code{FALSE}
#'   (the current behavior). Has no effect on a full-tile square heatmap
#'   (\code{method = "square"} without \code{scale.square}), whose tiles already
#'   carry a cell border (\code{outline.color}).
#' @param cell.grid.col the color of the \code{cell.grid} cell borders. Defaults
#'   to \code{"grey90"}. Only used when \code{cell.grid = TRUE}.
#' @param lower.method,upper.method character, an optional per-triangle glyph for
#'   a mixed layout: one of "square", "circle" or "number" (the coefficient drawn
#'   as text, colored by its value on the fill ramp). When either is set, the plot
#'   switches to a mixed layout where the lower and upper triangles are drawn
#'   separately and the variable names are drawn on the diagonal; a triangle left
#'   \code{NULL} uses \code{method}. Both default to \code{NULL} (single-method
#'   plot, unchanged). In a mixed layout the single-method significance and label
#'   overlays (\code{lab}, \code{sig.stars}, \code{p.mat}, \code{insig},
#'   \code{pch*}) do not apply; show coefficients with a "number" triangle instead.
#'
#'   Over a light background the "number" text is drawn on a darkened copy of the
#'   ramp -- same hues, so warm still reads as positive and cool as negative, but
#'   dark enough that a coefficient near zero stays readable instead of washing
#'   out. Over a dark background the ramp is used as given, its pale middle being
#'   what reads there. The background is taken from \code{ggtheme}; a theme added
#'   to the returned plot with \code{+} arrives too late to be seen.
#' @param type character, "full" (default), "lower" or "upper" display. A mixed
#'   layout (see \code{lower.method}/\code{upper.method}) always uses the full
#'   matrix.
#' @param ggtheme ggplot2 function or theme object. Default value is
#'   `theme_minimal`. Allowed values are the official ggplot2 themes including
#'   theme_gray, theme_bw, theme_minimal, theme_classic, theme_void, .... Theme
#'   objects are also allowed (e.g., `theme_classic()`). A mixed "number" region
#'   reads the background from this argument, resolved against the default theme
#'   in force when \code{ggcorrplot()} is called, to decide how dark to draw the
#'   coefficient text (see \code{lower.method}/\code{upper.method}). So a dark
#'   theme belongs here rather than added to the returned plot with \code{+}, and
#'   a \code{\link[ggplot2]{theme_set}} issued after the call is not seen.
#' @param title character, title of the graph.
#' @param show.legend logical, if TRUE the legend is displayed.
#' @param legend.title a character string for the legend title. lower
#'   triangular, upper triangular or full matrix.
#' @param show.diag NULL or logical, whether display the correlation
#'   coefficients on the principal diagonal. If \code{NULL}, the default is to
#'   show diagonal correlation for \code{type = "full"} and to remove it when
#'   \code{type} is one of "upper" or "lower".
#' @param colors a vector of colors for the fill gradient. The default is a
#'   length-3 vector for the low, mid and high correlation values (mapped with
#'   \code{\link[ggplot2]{scale_fill_gradient2}}). A vector of any other length
#'   (\code{>= 2}) is spread evenly across the scale with
#'   \code{\link[ggplot2]{scale_fill_gradientn}}, so an n-color palette (e.g.
#'   \code{RColorBrewer::brewer.pal(11, "RdBu")}) can be passed directly.
#' @param palette optional name of a built-in colorblind-safe diverging palette
#'   for the fill gradient: \code{"RdBu"} or \code{"PuOr"}. A convenience
#'   shortcut for \code{colors}: when set it supplies the gradient (an 11-stop
#'   ramp, white at zero, cool = negative / warm = positive) and takes precedence
#'   over \code{colors}. Defaults to \code{NULL} (use \code{colors}), so existing
#'   calls are unchanged.
#' @param preset optional name of a bundle of publication-grade defaults. The only
#'   value, \code{"publication"}, sets white cell outlines and the colorblind-safe
#'   \code{"RdBu"} palette in one token. It fills only the arguments you did not
#'   supply, so any argument you pass explicitly (e.g. \code{outline.color},
#'   \code{colors}, \code{palette}) overrides the preset. Defaults to \code{NULL}
#'   (no preset), leaving existing calls unchanged.
#' @param outline.color the outline color of square or circle. Default value is
#'   "gray".
#' @param hc.order logical value. If TRUE, correlation matrix will be hc.ordered
#'   using hclust function.
#' @param hc.method the agglomeration method to be used in hclust (see ?hclust).
#' @param hc.rect integer or \code{NULL} (default). If an integer \code{k}, draws
#'   \code{k} rectangles (no fill) around the clusters obtained by cutting the
#'   hierarchical tree, marking the cluster blocks on the diagonal. Requires
#'   \code{hc.order = TRUE} and \code{type = "full"} (the boxes span whole
#'   diagonal blocks). \code{NULL} (default) draws no rectangles. For a fully
#'   custom box style, add your own \code{annotate("rect", ...)} to the returned
#'   plot.
#' @param hc.rect.col the outline color of the \code{hc.rect} cluster rectangles.
#'   Defaults to \code{"gray30"}; set it to any color that suits your palette
#'   (e.g. \code{"black"} for a bolder box, or \code{"white"}). Only used when
#'   \code{hc.rect} is set.
#' @param lab logical value. If TRUE, add correlation coefficient on the plot.
#' @param lab_col,lab_size size and color to be used for the correlation
#'   coefficient labels. used when lab = TRUE.
#' @param lab_fontface the font face (\code{"plain"}, \code{"bold"},
#'   \code{"italic"}, \code{"bold.italic"}) for the correlation coefficient
#'   labels. Default is \code{"plain"}. Used when \code{lab = TRUE}.
#' @param sig.stars logical value. If \code{TRUE} and a \code{p.mat} is
#'   supplied, significance stars are appended to the coefficient labels
#'   (\code{***} for p <= 0.001, \code{**} for p <= 0.01, \code{*} for
#'   p <= 0.05), e.g. \code{"-0.85**"}. Only used when \code{lab = TRUE}. Default
#'   is \code{FALSE}. When \code{TRUE}, significance is shown by the stars and
#'   the \code{insig = "pch"} markers are not drawn. These three thresholds are
#'   fixed and are not affected by \code{sig.level}.
#' @param p.mat matrix of p-value. If NULL, arguments sig.level, insig, pch,
#'   pch.col, pch.cex is invalid.
#' @param sig.level significant level, if the p-value in p-mat is bigger than
#'   sig.level, then the corresponding correlation coefficient is regarded as
#'   insignificant. This governs which cells \code{insig = "pch"} marks and
#'   \code{insig = "blank"} wipes; the star thresholds used by
#'   \code{insig = "stars"} and \code{sig.stars} are fixed (see those arguments)
#'   and do not follow \code{sig.level}.
#' @param insig character, how to convey significance from \code{p.mat}: "pch"
#'   (default), "blank" or "stars". "pch" adds a character (see \code{pch}) on the
#'   glyphs of the insignificant cells; "blank" wipes those glyphs away; "stars"
#'   instead marks the SIGNIFICANT cells with significance stars
#'   (\code{***}/\code{**}/\code{*} for p <= 0.001/0.01/0.05 -- fixed thresholds,
#'   not \code{sig.level}). With the default
#'   \code{lab = FALSE} the stars are drawn on their own (in \code{pch.col}, sized
#'   by \code{lab_size}) as a standalone significance map; with \code{lab = TRUE}
#'   they are appended to the coefficient labels (e.g. \code{"-0.85***"}, as with
#'   \code{sig.stars}) so the two do not overprint.
#' @param pch add character on the glyphs of insignificant correlation
#'   coefficients (only valid when insig is "pch"). Default value is 4.
#' @param pch.col,pch.cex the color and the cex (size) of pch (only valid when
#'   insig is "pch").
#' @param tl.cex,tl.col,tl.srt the size, the color and the string rotation of
#'   text label (variable names). \code{tl.col} defaults to \code{NULL}, which
#'   inherits the color from the theme.
#' @param tl.vjust,tl.hjust the vertical and horizontal justification of the
#'   x-axis text labels, passed to \code{\link[ggplot2]{element_text}}. Both
#'   default to \code{1}; adjust them to reposition the variable-name labels.
#' @param digits Decides the number of decimal digits to be displayed (Default:
#'   `2`).
#' @param as.is retained for backward compatibility; no longer affects the plot.
#'   The axis is now always drawn in the matrix (row/column) order, so the
#'   variable-name handling this argument used to control is done internally.
#' @param nsmall the minimum number of digits to the right of the decimal point
#'   in the coefficient labels, passed to \code{\link[base]{format}}. Default is
#'   \code{0} (no minimum, current behavior). Set e.g. \code{nsmall = 2} to keep
#'   trailing zeros (such as 0.70). Only used when \code{lab = TRUE}.
#' @param leading.zero logical. If \code{TRUE} (default), coefficient labels keep
#'   the leading zero (e.g. \code{0.23}, \code{-0.67}). Set to \code{FALSE} to
#'   drop it (\code{.23}, \code{-.67}), which is common for correlation tables.
#'   Only used when \code{lab = TRUE}.
#' @param legend.limit a length-2 numeric vector giving the limits of the fill
#'   color scale. Default \code{c(-1, 1)} (suitable for a correlation matrix); set
#'   to \code{NULL} to use the data range instead, e.g. for a covariance matrix.
#' @param circle.scale a scaling factor for the circle sizes when
#'   \code{method = "circle"}. Default is \code{1}; increase it (e.g.
#'   \code{circle.scale = 2}) for larger circles or decrease it for smaller ones,
#'   which is useful when the output device size makes the default circles too
#'   small or too large. Has no effect when \code{method = "square"}.
#' @param coord.fixed logical value. If \code{TRUE} (default), the plot uses
#'   \code{\link[ggplot2]{coord_fixed}} so the cells are square. Set to
#'   \code{FALSE} to let the cells fill the plotting area (a non 1:1 aspect
#'   ratio), which can look better with many long variable names.
#' @return \itemize{ \item ggcorrplot(): Returns a ggplot2 \item cor_pmat():
#' Returns a matrix containing the p-values of correlations }
#' @examples
#' # Compute a correlation matrix
#' data(mtcars)
#' corr <- round(cor(mtcars), 1)
#' corr
#'
#' # Compute a matrix of correlation p-values
#' p.mat <- cor_pmat(mtcars)
#' p.mat
#'
#' # Visualize the correlation matrix
#' # --------------------------------
#' # method = "square" or "circle"
#' ggcorrplot(corr)
#' ggcorrplot(corr, method = "circle")
#'
#' # Mixed layout: a different glyph per triangle
#' # --------------------------------
#' # numbers in the lower triangle, circles in the upper, names on the diagonal
#' ggcorrplot(corr,
#'   lower.method = "number", upper.method = "circle",
#'   show.legend = FALSE
#' )
#'
#' # Reordering the correlation matrix
#' # --------------------------------
#' # using hierarchical clustering
#' ggcorrplot(corr, hc.order = TRUE, outline.color = "white")
#' # draw rectangles around the clusters
#' ggcorrplot(corr, hc.order = TRUE, hc.rect = 3, outline.color = "white")
#'
#' # Types of correlogram layout
#' # --------------------------------
#' # Get the lower triangle
#' ggcorrplot(corr,
#'   hc.order = TRUE, type = "lower",
#'   outline.color = "white"
#' )
#' # Get the upeper triangle
#' ggcorrplot(corr,
#'   hc.order = TRUE, type = "upper",
#'   outline.color = "white"
#' )
#'
#' # Change colors and theme
#' # --------------------------------
#' # Argument colors
#' ggcorrplot(corr,
#'   hc.order = TRUE, type = "lower",
#'   outline.color = "white",
#'   ggtheme = ggplot2::theme_gray,
#'   colors = c("#6D9EC1", "white", "#E46726")
#' )
#'
#' # Add correlation coefficients
#' # --------------------------------
#' # argument lab = TRUE
#' ggcorrplot(corr,
#'   hc.order = TRUE, type = "lower",
#'   lab = TRUE,
#'   ggtheme = ggplot2::theme_dark(),
#' )
#'
#' # Add correlation significance level
#' # --------------------------------
#' # Argument p.mat
#' # Barring the no significant coefficient
#' ggcorrplot(corr,
#'   hc.order = TRUE,
#'   type = "lower", p.mat = p.mat
#' )
#' # Leave blank on no significant coefficient
#' ggcorrplot(corr,
#'   p.mat = p.mat, hc.order = TRUE,
#'   type = "lower", insig = "blank"
#' )
#'
#' # Changing number of digits for correlation coeffcient
#' # --------------------------------
#' ggcorrplot(cor(mtcars),
#'   type = "lower",
#'   insig = "blank",
#'   lab = TRUE,
#'   digits = 3
#' )
#' @seealso
#'   \href{https://www.datanovia.com/learn/biostatistics/correlation/ggcorrplot-in-r}{ggcorrplot:
#'   Correlation Matrix Heatmap in R with ggplot2} for worked examples of the
#'   plot, and
#'   \href{https://www.datanovia.com/learn/biostatistics/correlation/correlation-matrix-in-r}{Correlation
#'   Matrix in R: Compute, Visualize & P-values} for computing the matrix and
#'   its p-values beforehand.
#' @name ggcorrplot
#' @rdname ggcorrplot
#' @export

# function body
ggcorrplot <- function(corr,
                       method = c("square", "circle"),
                       type = c("full", "lower", "upper"),
                       ggtheme = ggplot2::theme_minimal,
                       title = "",
                       show.legend = TRUE,
                       legend.title = "Corr",
                       show.diag = NULL,
                       colors = c("blue", "white", "red"),
                       outline.color = "gray",
                       hc.order = FALSE,
                       hc.method = "complete",
                       lab = FALSE,
                       lab_col = "black",
                       lab_size = 4,
                       lab_fontface = "plain",
                       sig.stars = FALSE,
                       p.mat = NULL,
                       sig.level = 0.05,
                       insig = c("pch", "blank", "stars"),
                       pch = 4,
                       pch.col = "black",
                       pch.cex = 5,
                       tl.cex = 12,
                       tl.col = NULL,
                       tl.srt = 45,
                       tl.vjust = 1,
                       tl.hjust = 1,
                       digits = 2,
                       as.is = FALSE,
                       nsmall = 0L,
                       leading.zero = TRUE,
                       legend.limit = c(-1, 1),
                       circle.scale = 1,
                       coord.fixed = TRUE,
                       lower.method = NULL,
                       upper.method = NULL,
                       hc.rect = NULL,
                       palette = NULL,
                       preset = NULL,
                       hc.rect.col = "gray30",
                       scale.square = FALSE,
                       cell.grid = FALSE,
                       cell.grid.col = "grey90") {
  type <- match.arg(type)
  method <- match.arg(method)
  # Resolve on insig[1] (not match.arg(insig)) so a caller passing the old
  # documented default vector explicitly -- insig = c("pch", "blank") -- still
  # collapses to its first element instead of erroring: match.arg() only accepts
  # a multi-value arg when it is identical to the full choices set, and adding
  # "stars" made c("pch", "blank") non-identical. Scalar/partial matching and the
  # default are unchanged.
  insig <- match.arg(insig[1], c("pch", "blank", "stars"))
  # A preset is a bundle of "publication-grade" defaults (white cell outlines and
  # a colorblind-safe diverging palette). It fills ONLY the arguments the caller
  # did not supply -- detected with missing() BEFORE any reassignment, so an
  # explicit argument always overrides the preset, and preset = NULL (the default)
  # changes nothing. This must run above the palette block, which reassigns
  # `colors`/`palette`.
  if (!is.null(preset)) {
    preset <- match.arg(preset, "publication")
    if (missing(outline.color)) outline.color <- "white"
    # Reach for the preset palette only when the caller pinned neither `palette`
    # nor `colors`, so an explicit `colors` is never clobbered.
    if (missing(palette) && missing(colors)) palette <- "RdBu"
  }
  # A named colorblind-safe diverging palette is a convenience shortcut for
  # `colors`: when set (non-NULL, the default), it supplies the fill gradient and
  # takes precedence over `colors`. `palette = NULL` leaves `colors` untouched, so
  # every existing call is unchanged.
  if (!is.null(palette)) {
    palette <- match.arg(palette, c("RdBu", "PuOr"))
    colors <- .ggcorrplot_palette(palette)
  }
  if (is.null(show.diag)) {
    if (type == "full") {
      show.diag <- TRUE
    } else {
      show.diag <- FALSE
    }
  }

  # Mixed layout: a different glyph per triangle (and the diagonal), requested via
  # the per-triangle arguments. Mixed mode fires only when at least one of them is
  # set, so every call that leaves them NULL (all existing calls) takes the
  # unchanged single-method path below and is byte-identical. "number" (a text
  # coefficient) is a value of these per-triangle arguments only; it is
  # deliberately NOT added to the scalar `method` choice set, whose match.arg must
  # keep resolving c("square","circle") to "square" (#85). The diagonal always
  # shows the variable names in a mixed layout (there is intentionally no
  # `diag.*` argument: any such name would start with "d" and make an abbreviated
  # `digits` call, e.g. `ggcorrplot(x, d = 2)`, ambiguous -- a CRAN regression).
  mixed <- !is.null(lower.method) || !is.null(upper.method)
  if (mixed) {
    glyphs <- c("square", "circle", "number")
    lower.method <- if (is.null(lower.method)) method else match.arg(lower.method, glyphs)
    upper.method <- if (is.null(upper.method)) method else match.arg(upper.method, glyphs)
    # A mixed layout draws both triangles and the diagonal, i.e. the full matrix.
    type <- "full"
    show.diag <- TRUE
    # The single-method coefficient/significance overlays do not apply to a mixed
    # layout (the coefficients are a region glyph via lower/upper.method =
    # "number"). Tell the user rather than dropping their arguments silently.
    if (lab || sig.stars || !is.null(p.mat)) {
      message(
        "In a mixed layout, `lab`, `sig.stars`, `p.mat`, `insig` and `pch*` are ",
        "not applied; use lower.method/upper.method = \"number\" to show the ",
        "coefficients."
      )
    }
  }

  if (inherits(corr, "cor_mat")) {
    # cor_mat object from rstatix
    cor.mat <- corr
    corr <- .tibble_to_matrix(cor.mat)
    p.mat <- .tibble_to_matrix(attr(cor.mat, "pvalue"))
  }

  if (!is.matrix(corr) & !is.data.frame(corr)) {
    stop("Need a matrix or data frame!")
  }
  corr <- as.matrix(corr)

  if (mixed) {
    if (nrow(corr) != ncol(corr)) {
      stop("A mixed layout (lower.method/upper.method) requires a square ",
           "correlation matrix.", call. = FALSE)
    }
    # The mixed layout splits cells by grid position and names the diagonal from
    # the row variable, so the diagonal is only meaningful when the row and column
    # names match (as they do for any correlation matrix). Refuse a square matrix
    # with differing row/column names rather than silently mislabelling it.
    if (!identical(rownames(corr), colnames(corr))) {
      stop("A mixed layout requires the correlation matrix to have matching row ",
           "and column names.", call. = FALSE)
    }
  }

  # Transform the correlation (and matching p-value) matrix into the long
  # data frames the plot is built from: reorder, round, mask a triangle, melt,
  # and join per-cell significance. Extracted so the mixed-method path can reuse
  # exactly the same pipeline (P0.0). Returns the melted `corr` data frame and
  # the insignificant-cells `p.mat` data frame (or NULL).
  built <- .build_corr_df(
    corr = corr, p.mat = p.mat, type = type, show.diag = show.diag,
    hc.order = hc.order, hc.method = hc.method, digits = digits,
    sig.level = sig.level,
    # A mixed layout does not overlay significance, so the insig = "blank"
    # value-zeroing must not run here: otherwise a "number" region would print a
    # literal 0 for a non-significant cell instead of its coefficient. Force the
    # non-blanking path when mixed so the numbers stay the true coefficients.
    insig = if (mixed) "pch" else insig,
    as.is = as.is
  )
  corr <- built$corr
  p.mat <- built$p.mat
  hc <- built$hc

  # heatmap
  if (mixed) {
    # Pin BOTH axes to ONE level order, taken from the matrix order that
    # .build_corr_df() already established: its factor levels for a named matrix,
    # or the sorted integer indices for an unnamed one (which melts to 1..n).
    # Deriving the two axes independently from the order the cells happen to
    # appear in after melt() dropped the NA cells puts them out of step whenever
    # the NA pattern is ragged -- cor(x, use = "pairwise.complete.obs") with a
    # non-co-occurring pair, or a zero-variance column, both produce one -- and
    # then the region split below compares positions on two different axes, so
    # the diagonal name region lands on cells that are not self-pairs and
    # silently mislabels them. A level absent from the data on BOTH axes (an
    # all-NA variable) is dropped so the drop = FALSE axes do not resurrect it as
    # an empty band; a variable that still has data on one axis is kept.
    lvls <- if (is.factor(corr$Var1)) {
      levels(corr$Var1)
    } else {
      as.character(sort(unique(c(corr$Var1, corr$Var2))))
    }
    present <- unique(c(as.character(corr$Var1), as.character(corr$Var2)))
    lvls <- lvls[lvls %in% present]
    corr$Var1 <- factor(as.character(corr$Var1), levels = lvls)
    corr$Var2 <- factor(as.character(corr$Var2), levels = lvls)

    # One glyph per region, each drawn from its own subset of the cells. The base
    # plot carries no global fill so the text glyphs ("number"/"name") are not
    # forced to inherit it; each glyph layer sets the aesthetics it needs.
    p <- ggplot2::ggplot(
      data = corr,
      mapping = ggplot2::aes(x = .data[["Var1"]], y = .data[["Var2"]])
    )
    p <- p + .mixed_layers(
      corr, lower.method, upper.method,
      outline.color = outline.color, circle.scale = circle.scale,
      lab_size = lab_size, tl.cex = tl.cex, tl.col = tl.col,
      digits = digits, nsmall = nsmall, leading.zero = leading.zero,
      scale.square = scale.square,
      cell.grid = cell.grid, cell.grid.col = cell.grid.col
    )
    # A mixed layout always boxes at least the diagonal (name) region when
    # cell.grid = TRUE, so the gridline blanking below is always consistent here.
    draw.cell.grid <- cell.grid
  } else {
    p <-
      ggplot2::ggplot(
        data = corr,
        mapping = ggplot2::aes(x = .data[["Var1"]], y = .data[["Var2"]], fill = .data[["value"]])
      )

    # cell.grid: draw a light cell-rectangle grid BEHIND the sized glyphs so they
    # sit inside boxed cells (the corrplot look). Added before the glyph layer so
    # it renders underneath. Skipped for a full-tile square heatmap (method =
    # "square" without scale.square): its geom_tile already carries a cell border
    # (outline.color), so a second border would double-draw. fill = NA overrides
    # the inherited aes(fill = value) for drawing while still training the same
    # fill scale as the glyph layer (byte-identical fill legend).
    draw.cell.grid <- cell.grid && !(method == "square" && !scale.square)
    if (draw.cell.grid) {
      p <- p + ggplot2::geom_tile(fill = NA, colour = cell.grid.col)
    }

    # modification based on method (extracted so the mixed-method path can request
    # a different glyph per triangle from the same builder, P0.0)
    p <- p + .method_layer(method,
      outline.color = outline.color, circle.scale = circle.scale,
      scale.square = scale.square
    )
  }

  # adding colors
  if (length(colors) < 2) {
    stop("'colors' must contain at least 2 colors.", call. = FALSE)
  }
  if (length(colors) == 3) {
    p <- p + ggplot2::scale_fill_gradient2(
      low = colors[1],
      high = colors[3],
      mid = colors[2],
      midpoint = 0,
      limit = legend.limit,
      space = "Lab",
      name = legend.title
    )
  } else {
    # any palette that is not exactly low/mid/high: spread the colors evenly
    # across the scale with gradientn. Lets users pass e.g. an 11-color
    # RColorBrewer palette directly, without adding a second fill scale (#52).
    p <- p + ggplot2::scale_fill_gradientn(
      colours = colors,
      limits = legend.limit,
      name = legend.title
    )
  }

  # A "number" region colours its text by the correlation value, so it needs a
  # colour scale that matches the fill scale. When a square/circle region also
  # draws fill, that fill scale carries the legend and the (redundant) colour
  # guide is suppressed; when numbers are the ONLY value encoding (e.g. both
  # triangles are "number"), the colour scale carries the legend instead, so the
  # plot is never left legend-less.
  if (mixed && "number" %in% c(lower.method, upper.method)) {
    has_fill_glyph <- any(c(lower.method, upper.method) %in% c("square", "circle"))
    colour_name <- if (has_fill_glyph) ggplot2::waiver() else legend.title
    # Text needs contrast that a fill does not: the fill ramp is centered on
    # white, so mapping the coefficient TEXT onto it unchanged makes every
    # near-zero coefficient invisible against the panel -- and a blank cell in a
    # correlogram reads as removed/non-significant, so an unreadable number is
    # misleading, not merely faint. Darken the ramp for the text only, keeping
    # each stop's hue (so warm = positive / cool = negative still reads at a
    # glance) but capping its luminance -- and only when the panel is light, since
    # on a dark panel the pale middle is already the readable end.
    text_colors <- if (.panel_is_light(ggtheme)) .legible_text_colors(colors) else colors
    if (length(colors) == 3) {
      p <- p + ggplot2::scale_colour_gradient2(
        low = text_colors[1], high = text_colors[3], mid = text_colors[2],
        midpoint = 0, limit = legend.limit, space = "Lab", name = colour_name
      )
    } else {
      p <- p + ggplot2::scale_colour_gradientn(
        colours = text_colors, limits = legend.limit, name = colour_name
      )
    }
    if (has_fill_glyph) p <- p + ggplot2::guides(colour = "none")
  }

  # depending on the class of the object, add the specified theme
  if (class(ggtheme)[[1]] == "function") {
    p <- p + ggtheme()
  } else if (class(ggtheme)[[1]] == "theme") {
    p <- p + ggtheme
  }


  p <- p +
    ggplot2::theme(
      axis.text.x = ggplot2::element_text(
        angle = tl.srt,
        vjust = tl.vjust,
        size = tl.cex,
        hjust = tl.hjust,
        colour = tl.col
      ),
      axis.text.y = ggplot2::element_text(size = tl.cex, colour = tl.col)
    )
  # cell.grid replaces the through-center gridlines with per-cell rectangles, so
  # blank the panel grid (added after the theme() above so it wins). Gated on
  # draw.cell.grid -- TRUE only when boxes were actually drawn -- so a full-tile
  # square heatmap (which draws no box and keeps its gridlines behind the opaque
  # tiles) is genuinely untouched, matching the documented "no effect". This also
  # keeps a lower/upper full-tile square's gridlines in the blank triangle intact.
  if (draw.cell.grid) {
    p <- p + ggplot2::theme(
      panel.grid.major = ggplot2::element_blank(),
      panel.grid.minor = ggplot2::element_blank()
    )
  }
  if (coord.fixed) {
    p <- p + ggplot2::coord_fixed()
  } else {
    p <- p + ggplot2::coord_cartesian()
  }

  # The coefficient-label overlay and the significance glyphs are single-method
  # features. In a mixed layout the coefficients are a region glyph
  # (method.* = "number") and significance is not overlaid, so this whole block
  # is skipped; a non-mixed call runs it exactly as before.
  if (!mixed) {
    label <- .format_coef(corr[, "value"], digits = digits, nsmall = nsmall,
                          leading.zero = leading.zero)
    # Append significance stars to the coefficient labels for sig.stars, and also
    # for insig = "stars" when labels are shown (lab = TRUE): the stars share the
    # label's cell center, so routing them into the suffix here -- rather than
    # adding the standalone geom_text below -- avoids two text layers overprinting
    # into illegible output. For all other insig values this reduces to the
    # sig.stars condition exactly as before (byte-identical).
    if ((sig.stars || insig == "stars") && !is.null(p.mat)) {
      label <- paste0(label, .sig_stars(corr$pvalue))
    }
    if (!is.null(p.mat) & insig == "blank") {
      ns <- corr$pvalue > sig.level
      ns[is.na(ns)] <- FALSE
      if (sum(ns) > 0) label[ns] <- " "
    }

    # matrix cell labels
    if (lab) {
      p <- p +
        ggplot2::geom_text(
          mapping = ggplot2::aes(x = .data[["Var1"]], y = .data[["Var2"]]),
          label = label,
          color = lab_col,
          size = lab_size,
          fontface = lab_fontface
        )
    }

    # matrix cell glyphs
    if (!is.null(p.mat) & insig == "pch" & !sig.stars) {
      p <- p + ggplot2::geom_point(
        data = p.mat,
        mapping = ggplot2::aes(x = .data[["Var1"]], y = .data[["Var2"]]),
        shape = pch,
        size = pch.cex,
        color = pch.col
      )
    }

    # standalone significance stars: mark the SIGNIFICANT cells with */**/***
    # (non-significant cells get nothing) as a significance-only map. Only drawn
    # when lab = FALSE; with lab = TRUE the stars are appended to the coefficient
    # labels above (numbers + stars, one text layer) so the two do not overprint.
    if (!is.null(p.mat) & insig == "stars" & !lab) {
      p <- p + ggplot2::geom_text(
        mapping = ggplot2::aes(x = .data[["Var1"]], y = .data[["Var2"]]),
        label = .sig_stars(corr$pvalue),
        color = pch.col,
        size = lab_size
      )
    }
  }

  # cluster rectangles: draw hc.rect boxes around the k clusters obtained by
  # cutting the dendrogram. Requires hc.order (so the variables are in dendrogram
  # order and each cluster is a contiguous block). The blocks are full squares on
  # the diagonal, so they are only meaningful on the full matrix -- on a lower/
  # upper triangle a box would extend over the blanked half. Added on top of the
  # glyphs.
  if (!is.null(hc.rect)) {
    if (!hc.order) {
      stop("hc.rect requires hc.order = TRUE.", call. = FALSE)
    }
    if (type != "full") {
      stop("hc.rect requires type = \"full\"; the cluster boxes span the whole ",
           "diagonal block and would extend over the hidden triangle otherwise.",
           call. = FALSE)
    }
    # The box positions are grid indices 1..n in dendrogram order; they line up
    # because .build_corr_df() coerces the axis to a factor in that order, so
    # numeric-looking or as.is names no longer sort the axis by value/alphabet.
    k <- hc.rect
    n <- length(hc$order)
    if (!is.numeric(k) || length(k) != 1L || is.na(k) || k < 1 || k > n ||
        k != as.integer(k)) {
      stop("hc.rect must be a single integer between 1 and ", n,
           " (the number of variables).", call. = FALSE)
    }
    b <- .hc_rect_bounds(hc, k)
    # No linewidth/size: the default border keeps this compatible with the
    # declared ggplot2 floor (linewidth is a ggplot2 >= 3.4.0 aesthetic).
    p <- p + ggplot2::annotate(
      "rect",
      xmin = b$lo - 0.5, xmax = b$hi + 0.5,
      ymin = b$lo - 0.5, ymax = b$hi + 0.5,
      fill = NA, colour = hc.rect.col
    )
  }

  # add titles
  if (title != "") {
    p <- p +
      ggplot2::ggtitle(title)
  }

  # removing legend
  if (!show.legend) {
    p <- p +
      ggplot2::theme(legend.position = "none")
  }

  # removing panel
  p <- p +
    .no_panel()
  p
}



#' Compute the matrix of correlation p-values
#'
#' @details \code{cor_pmat()} tests each pair of columns with
#'   \code{\link[stats]{cor.test}}. A pair with fewer than three overlapping
#'   non-missing observations (which \code{\link[stats]{cor.test}} cannot test,
#'   e.g. two variables that never co-occur) yields \code{NA} for that cell
#'   rather than aborting the whole computation. Pairs that can be tested are
#'   computed as before, and errors they raise are passed through.
#'
#'   The \code{use} argument controls which pairs are returned as \code{NA} so
#'   the p-value matrix can be aligned with a correlation matrix built the same
#'   way. With the default \code{"pairwise.complete.obs"} every pair that has
#'   enough overlapping observations is tested (the previous behavior). With
#'   \code{"everything"} a pair is set to \code{NA} whenever either variable has
#'   any missing value, so the \code{NA} pattern matches
#'   \code{\link[stats]{cor}(x)} with its default \code{use = "everything"}.
#'
#' @param x numeric matrix or data frame
#' @param ... other arguments to be passed to the function cor.test.
#' @param use character, how to treat pairs involving missing values when
#'   deciding which cells are \code{NA}. Either \code{"pairwise.complete.obs"}
#'   (default; test every pair that has enough overlapping observations) or
#'   \code{"everything"} (set a pair to \code{NA} as soon as either variable has
#'   a missing value, matching \code{\link[stats]{cor}}'s default). Mirrors the
#'   corresponding values of \code{\link[stats]{cor}}'s \code{use} argument.
#' @seealso
#'   \href{https://www.datanovia.com/learn/biostatistics/correlation/correlation-test-in-r}{Correlation
#'   Test in R: Pearson, Spearman & Kendall} for the test behind the p-values.
#' @rdname ggcorrplot
#' @export

cor_pmat <- function(x, ..., use = c("pairwise.complete.obs", "everything")) {

  use <- match.arg(use)

  # initializing values
  mat <- as.matrix(x)
  n <- ncol(mat)
  p.mat <- matrix(NA, n, n)
  diag(p.mat) <- 0

  # Pattern of pairs to leave as NA, taken from cor() under the same `use`, so
  # the result can be aligned with a cor(x, use = ...) matrix (#51). This is
  # missingness-driven, so it does not depend on the correlation method passed
  # through `...`; computing the mask with cor()'s default (pearson) is fine.
  cor_mask <- stats::cor(mat, use = use)

  # creating the p-value matrix
  for (i in 1:(n - 1)) {
    for (j in (i + 1):n) {
      if (is.na(cor_mask[i, j])) {
        # cor() could not compute this pair under `use`: leave it NA.
        p.mat[i, j] <- p.mat[j, i] <- NA_real_
      } else {
        # a pair with too few overlapping observations (e.g. two variables that
        # never co-occur) makes cor.test() error; return NA for that cell instead
        # of aborting the whole matrix (#51). The NA substitution is gated on the
        # overlap count, so for any pair that CAN be tested (>= 3 overlapping obs)
        # a genuine error (bad method =, non-numeric input, ...) is re-raised and
        # still surfaces loudly instead of silently becoming NA.
        p.mat[i, j] <- p.mat[j, i] <- tryCatch(
          stats::cor.test(mat[, i], mat[, j], ...)$p.value,
          error = function(e) {
            if (sum(stats::complete.cases(mat[, i], mat[, j])) < 3) {
              NA_real_
            } else {
              stop(e)
            }
          }
        )
      }
    }
  }

  # name rows and columns of the p-value matrix
  colnames(p.mat) <- rownames(p.mat) <- colnames(mat)

  # return the final matrix
  p.mat
}



#+++++++++++++++++++++++
# Helper Functions
#+++++++++++++++++++++++

# Reorder -> round -> mask a triangle -> melt -> join per-cell significance.
# Takes the already-coerced correlation matrix and (optional) p-value matrix and
# the resolved show.diag, and returns the two long data frames the plot layers
# are built from:
#   $corr  : melted correlation data frame (Var1, Var2, value, pvalue, signif,
#            [coef], abs_corr)
#   $p.mat : the insignificant-cells data frame used by the insig = "pch" layer,
#            or NULL when no p.mat was supplied.
# Behaviour is identical to the inline pipeline it was extracted from (P0.0); the
# order of operations matters (round happens AFTER clustering and the
# significance test, #14/#25) and is preserved exactly.
.build_corr_df <- function(corr, p.mat, type, show.diag, hc.order, hc.method,
                           digits, sig.level, insig, as.is) {
  # Reordering and the triangular layouts require a square matrix; a non-square
  # (m x n) correlation matrix can only be shown in full (#5, #10).
  if (nrow(corr) != ncol(corr)) {
    if (hc.order) {
      stop("hc.order = TRUE requires a square correlation matrix.")
    }
    if (type != "full") {
      stop("type = '", type, "' requires a square correlation matrix; ",
           "use type = 'full' for a non-square matrix.")
    }
  }

  # Order on the unrounded matrix so the internal rounding below does not
  # introduce ties that perturb the hierarchical clustering (#14).
  hc <- NULL
  if (hc.order) {
    hc <- .hc_cormat_order(corr, hc.method = hc.method)
    ord <- hc$order
    corr <- corr[ord, ord]
    if (!is.null(p.mat)) {
      p.mat <- p.mat[ord, ord]
    }
  }

  corr <- base::round(x = corr, digits = digits)

  if (!show.diag) {
    corr <- .remove_diag(corr)
    p.mat <- .remove_diag(p.mat)
  }

  # Get lower or upper triangle
  if (type == "lower") {
    corr <- .get_lower_tri(corr, show.diag)
    p.mat <- .get_lower_tri(p.mat, show.diag)
  } else if (type == "upper") {
    corr <- .get_upper_tri(corr, show.diag)
    p.mat <- .get_upper_tri(p.mat, show.diag)
  }

  # The plot must display the variables in the matrix row/column order (which
  # carries the hc.order reordering). Capture that order before melting, then
  # coerce the axis back to a factor with these levels so the display order never
  # depends on how the names happen to sort (#37). Melting with as.is = TRUE keeps
  # the dimnames VERBATIM -- reshape2::melt's default type-conversion would turn
  # numeric-looking names into their numeric values, so as.character() of a
  # non-canonical name (e.g. "01", "1.10", "1e2") would no longer match the
  # captured level and every cell would collapse to NA. `unique()` guards the
  # pathological case of duplicated names (which would otherwise error on the
  # factor's duplicate levels).
  # Only named axes carry a meaningful order to preserve; an unnamed axis melts to
  # integer indices 1..n, which are already in row order, so it is left exactly as
  # before (a continuous axis) -- coercing it would be an unnecessary behavior
  # change for that input. Rows and columns are gated independently so a
  # partially-named matrix keeps whichever axis has names.
  row_levels <- if (!is.null(rownames(corr))) unique(rownames(corr)) else NULL
  col_levels <- if (!is.null(colnames(corr))) unique(colnames(corr)) else NULL

  # Melt corr and pmat
  corr <- reshape2::melt(corr, na.rm = TRUE, as.is = TRUE)
  colnames(corr) <- c("Var1", "Var2", "value")
  if (!is.null(row_levels)) corr$Var1 <- factor(as.character(corr$Var1), levels = row_levels)
  if (!is.null(col_levels)) corr$Var2 <- factor(as.character(corr$Var2), levels = col_levels)
  corr$pvalue <- rep(NA, nrow(corr))
  corr$signif <- rep(NA, nrow(corr))

  if (!is.null(p.mat)) {
    p.mat <- reshape2::melt(p.mat, na.rm = TRUE, as.is = TRUE)
    colnames(p.mat) <- c("Var1", "Var2", "value")
    if (!is.null(row_levels)) p.mat$Var1 <- factor(as.character(p.mat$Var1), levels = row_levels)
    if (!is.null(col_levels)) p.mat$Var2 <- factor(as.character(p.mat$Var2), levels = col_levels)
    # Match each p-value to its correlation cell by (Var1, Var2) rather than by
    # row position, so a differing NA pattern between corr and p.mat cannot
    # misalign them (or raise a length error). When the patterns match, the
    # match is the identity and the result is byte-identical.
    idx <- match(
      paste(corr$Var1, corr$Var2, sep = "\r"),
      paste(p.mat$Var1, p.mat$Var2, sep = "\r")
    )
    corr$coef <- corr$value
    corr$pvalue <- p.mat$value[idx]
    corr$signif <- as.numeric(corr$pvalue <= sig.level)
    p.mat <- subset(p.mat, p.mat$value > sig.level)
    # keep significance markers only for cells present in the correlation plot
    p.mat <- p.mat[paste(p.mat$Var1, p.mat$Var2, sep = "\r") %in%
      paste(corr$Var1, corr$Var2, sep = "\r"), ]
    if (insig == "blank") {
      # a cell with no matching p-value (unknown significance) is kept as-is
      keep <- ifelse(is.na(corr$signif), 1, corr$signif)
      corr$value <- corr$value * keep
    }
  } else {
    p.mat <- NULL
  }

  corr$abs_corr <- abs(corr$value) * 10

  # `hc` is the hclust object when hc.order = TRUE (needed for hc.rect), else NULL.
  list(corr = corr, p.mat = p.mat, hc = hc)
}

# Build the glyph layer(s) for a given method. Returns a list of ggplot
# components so the caller can add them with a single `+` (and so the
# mixed-method path can request a different glyph per triangle, P0.0).
.method_layer <- function(method, outline.color, circle.scale, scale.square = FALSE) {
  if (method == "square" && !scale.square) {
    list(ggplot2::geom_tile(color = outline.color))
  } else if (method == "square" && scale.square) {
    # size-scaled squares (corrplot-style): a filled square (shape 22) whose size
    # encodes |r|, mirroring the sized-circle glyph. Only reached when the caller
    # opts in with scale.square = TRUE, so the default square heatmap is unchanged.
    list(
      ggplot2::geom_point(
        color = outline.color,
        shape = 22,
        ggplot2::aes(size = .data[["abs_corr"]])
      ),
      ggplot2::scale_size(range = c(4, 10) * circle.scale),
      ggplot2::guides(size = "none")
    )
  } else if (method == "circle") {
    list(
      ggplot2::geom_point(
        color = outline.color,
        shape = 21,
        ggplot2::aes(size = .data[["abs_corr"]])
      ),
      ggplot2::scale_size(range = c(4, 10) * circle.scale),
      ggplot2::guides(size = "none")
    )
  }
}

# Format the correlation coefficients for display: round to `digits`, optionally
# pad to `nsmall` decimals, optionally drop the leading zero. Shared by the
# single-method label overlay and the mixed "number" glyph so they format the
# same way.
.format_coef <- function(x, digits, nsmall, leading.zero) {
  label <- round(x = x, digits = digits)
  if (nsmall > 0) label <- format(label, nsmall = nsmall, trim = TRUE)
  if (!leading.zero) {
    # drop the leading zero of values in (-1, 1), e.g. 0.23 -> .23, -0.67 -> -.67
    # (idiom from @PawelKulawiak, #15). The \\b keeps values like 1.00 untouched.
    label <- gsub("\\b0(\\.\\d+)", "\\1", label)
  }
  label
}

# Significance stars for a vector of p-values: "***" p <= 0.001, "**" p <= 0.01,
# "*" p <= 0.05, "" otherwise (and "" for NA). The cut() breaks below are
# right-closed, so each threshold is inclusive. Shared by the sig.stars label
# suffix and the standalone insig = "stars" glyph so both use one definition.
.sig_stars <- function(pvalue) {
  stars <- as.character(cut(pvalue,
    breaks = c(-Inf, 0.001, 0.01, 0.05, Inf),
    labels = c("***", "**", "*", "")
  ))
  stars[is.na(stars)] <- ""
  stars
}

# Build the layers for a mixed layout: a per-triangle glyph over the lower
# triangle (Var1 index > Var2 index) and the upper triangle, plus the variable
# names on the diagonal. Each region is a subset of the melted correlation data
# frame drawn with its own layer so the glyphs can differ. "square"/"circle" draw
# the usual glyphs; "number" draws the coefficient as text colored by value
# (matched by a colour scale added in the caller); the diagonal always draws the
# variable name. Returns a list of ggplot components.
.mixed_layers <- function(df, lower.method, upper.method,
                          outline.color, circle.scale, lab_size, tl.cex, tl.col,
                          digits, nsmall, leading.zero, scale.square = FALSE,
                          cell.grid = FALSE, cell.grid.col = "grey90") {
  xi <- as.integer(df$Var1)
  yi <- as.integer(df$Var2)
  regions <- list(
    list(data = df[xi > yi, , drop = FALSE], method = lower.method),
    list(data = df[xi < yi, , drop = FALSE], method = upper.method),
    list(data = df[xi == yi, , drop = FALSE], method = "name")
  )

  layers <- list()
  has_sized <- FALSE
  for (r in regions) {
    d <- r$data
    if (nrow(d) == 0) next
    m <- r$method
    # cell.grid: box every region behind its glyph, EXCEPT a full-tile square
    # region (m == "square" without scale.square), whose geom_tile already draws
    # an outline.color border -- a second box would double-draw. Added before the
    # region's glyph so it renders underneath. fill = NA (no aes fill inherited
    # from the mixed base plot) draws only the border.
    if (cell.grid && !(m == "square" && !scale.square)) {
      layers <- c(layers, list(ggplot2::geom_tile(
        data = d, fill = NA, colour = cell.grid.col
      )))
    }
    if (m == "square" && !scale.square) {
      layers <- c(layers, list(ggplot2::geom_tile(
        data = d,
        mapping = ggplot2::aes(fill = .data[["value"]]),
        color = outline.color
      )))
    } else if (m == "square" && scale.square) {
      has_sized <- TRUE
      layers <- c(layers, list(ggplot2::geom_point(
        data = d,
        mapping = ggplot2::aes(fill = .data[["value"]], size = .data[["abs_corr"]]),
        color = outline.color, shape = 22
      )))
    } else if (m == "circle") {
      has_sized <- TRUE
      layers <- c(layers, list(ggplot2::geom_point(
        data = d,
        mapping = ggplot2::aes(fill = .data[["value"]], size = .data[["abs_corr"]]),
        color = outline.color, shape = 21
      )))
    } else if (m == "number") {
      layers <- c(layers, list(ggplot2::geom_text(
        data = d,
        mapping = ggplot2::aes(colour = .data[["value"]]),
        label = .format_coef(d$value, digits, nsmall, leading.zero),
        size = lab_size
      )))
    } else if (m == "name") {
      layers <- c(layers, list(ggplot2::geom_text(
        data = d,
        mapping = ggplot2::aes(label = .data[["Var1"]]),
        colour = if (is.null(tl.col)) "black" else tl.col,
        size = tl.cex / 3
      )))
    }
  }

  if (has_sized) {
    layers <- c(layers, list(
      ggplot2::scale_size(range = c(4, 10) * circle.scale),
      ggplot2::guides(size = "none")
    ))
  }

  # Each region is a separate layer over a subset of the cells, so a variable
  # absent from one region's subset (e.g. the first variable never appears in the
  # lower triangle) would otherwise make ggplot infer that axis's order from the
  # cells it does see, misaligning the two axes and bending the diagonal. Pin both
  # axes to the full variable order so every cell lands on the shared grid.
  lvls_x <- if (is.factor(df$Var1)) levels(df$Var1) else unique(as.character(df$Var1))
  lvls_y <- if (is.factor(df$Var2)) levels(df$Var2) else unique(as.character(df$Var2))
  layers <- c(layers, list(
    ggplot2::scale_x_discrete(limits = lvls_x, drop = FALSE),
    ggplot2::scale_y_discrete(limits = lvls_y, drop = FALSE)
  ))

  layers
}

# Get lower triangle of the correlation matrix
.get_lower_tri <- function(cormat, show.diag = FALSE) {
  if (is.null(cormat)) {
    return(cormat)
  }
  cormat[upper.tri(cormat)] <- NA
  if (!show.diag) {
    diag(cormat) <- NA
  }
  return(cormat)
}

# Get upper triangle of the correlation matrix
.get_upper_tri <- function(cormat, show.diag = FALSE) {
  if (is.null(cormat)) {
    return(cormat)
  }
  cormat[lower.tri(cormat)] <- NA
  if (!show.diag) {
    diag(cormat) <- NA
  }
  return(cormat)
}

.remove_diag <- function(cormat) {
  if (is.null(cormat)) {
    return(cormat)
  }
  if (nrow(cormat) == ncol(cormat)) {
    diag(cormat) <- NA
  } else {
    # A non-square (m x n) matrix has no positional diagonal: `diag(cormat) <- NA`
    # would blank min(m, n) cells at (1,1), (2,2), ... regardless of what variables
    # sit there, wiping the wrong cells. Remove only the genuine self-pairs -- cells
    # whose row and column name the same variable -- so a matrix whose row and column
    # variables are disjoint keeps every cell.
    rn <- rownames(cormat)
    cn <- colnames(cormat)
    if (!is.null(rn) && !is.null(cn)) {
      cormat[outer(rn, cn, `==`)] <- NA
    } else {
      # Unnamed matrix: there are no names to identify self-pairs by, so keep the
      # historical positional removal (unchanged from previous behavior).
      diag(cormat) <- NA
    }
  }
  cormat
}

# Named colorblind-safe diverging palettes, as hardcoded hex vectors (the package
# targets R >= 3.3, which predates hcl.colors(), and Imports are kept minimal, so
# the values are not computed at run time). Each is an 11-stop ColorBrewer
# diverging ramp with white at the center, ordered low -> high (cool = negative,
# warm = positive) to match the default colors = c("blue", "white", "red")
# polarity. Verified against RColorBrewer::brewer.pal(11, .) at development time.
.ggcorrplot_palette <- function(name) {
  switch(name,
    RdBu = c(
      "#053061", "#2166AC", "#4393C3", "#92C5DE", "#D1E5F0", "#F7F7F7",
      "#FDDBC7", "#F4A582", "#D6604D", "#B2182B", "#67001F"
    ),
    PuOr = c(
      "#2D004B", "#542788", "#8073AC", "#B2ABD2", "#D8DAEB", "#F7F7F7",
      "#FEE0B6", "#FDB863", "#E08214", "#B35806", "#7F3B08"
    )
  )
}
# Darken a vector of colors just enough to be readable as TEXT on a white panel,
# keeping each color's hue. Used only for the mixed "number" glyph, whose text is
# mapped onto the same diverging ramp as the fill: that ramp is white at zero, so
# an unmodified near-zero coefficient renders invisible.
#
# Relative luminance is the WCAG definition (linearised sRGB, Rec. 709 weights).
# A color already at or below the cap is returned unchanged (a saturated blue, a
# dark ramp end); everything else is scaled down, the pale middle by far the most
# and a stop only just over the cap barely at all. Scaling the linear channels by
# a common factor preserves the hue. The
# cap keeps the contrast ratio against white above 4.5:1, the usual threshold for
# small text, with enough headroom that rounding to 8-bit channels cannot push a
# stop back under it.
#
# A partly transparent stop is left alone: its luminance over the panel depends on
# what it is composited with, so darkening it by its opaque value would neither
# honour the contrast target nor keep the ramp's alpha uniform. Whatever the
# caller asked for is drawn unchanged, exactly as the fill scale draws it.
.legible_text_colors <- function(colors, max_luminance = 0.179) {
  unlist(lapply(colors, function(col) {
    rgba <- grDevices::col2rgb(col, alpha = TRUE)[, 1] / 255
    if (is.na(rgba[4]) || rgba[4] < 1) {
      return(col)
    }
    chan <- .linearise_srgb(rgba[1:3])
    lum <- sum(c(0.2126, 0.7152, 0.0722) * chan)
    if (is.na(lum) || lum <= max_luminance) {
      return(col)
    }
    chan <- chan * (max_luminance / lum)
    # back to sRGB
    srgb <- ifelse(chan <= 0.0031308, chan * 12.92, 1.055 * chan^(1 / 2.4) - 0.055)
    grDevices::rgb(srgb[1], srgb[2], srgb[3])
  }), use.names = FALSE)
}

# sRGB -> linear light, the first half of the WCAG relative-luminance definition.
.linearise_srgb <- function(u) {
  ifelse(u <= 0.03928, u / 12.92, ((u + 0.055) / 1.055)^2.4)
}

.relative_luminance <- function(col) {
  chan <- .linearise_srgb(grDevices::col2rgb(col)[, 1] / 255)
  sum(c(0.2126, 0.7152, 0.0722) * chan)
}

# Is the background behind the glyphs light enough that DARK text reads against
# it? The legibility floor only helps there: on a dark background the ramp's pale
# middle is already the READABLE end (white on grey50 clears 3.9:1), and darkening
# it would bury the text instead. So the floor is applied over a light background
# only, and a dark theme keeps the plain ramp.
#
# What sits behind a cell is panel.background when the theme draws one, and
# plot.background when it does not -- theme_minimal (our default) and theme_void
# blank the panel, so a dark recipe built on them carries its color on
# plot.background. Both are consulted, in that order, and each is resolved through
# the theme's inheritance before falling back to the raw element. A background we
# cannot resolve at all counts as light, which is the default device background.
#
# This sees the theme passed as `ggtheme`, resolved against the active default, so
# a globally theme_set() background counts too. A theme added to the finished plot
# with `+` arrives long after the scale is built, so a dark theme must be passed
# here to be taken into account; that limitation is documented on the arguments.
#
# The threshold is where the two branches break even FOR THE NEAR-ZERO STOP -- the
# pale middle of the ramp, which is the one the floor exists to rescue and the one
# that vanishes first. It is not a promise about the ramp as a whole: against a
# mid-grey panel a white-centred diverging ramp always has some intermediate stop
# at roughly the panel's own luminance, so neither branch reads well there and no
# threshold rescues it. Away from mid-grey, in both directions, the branch this
# picks is comfortably the better one.
.panel_is_light <- function(ggtheme, threshold = 0.44) {
  fill <- tryCatch(
    {
      th <- if (is.function(ggtheme)) ggtheme() else ggtheme
      # ggplot2 draws theme_get() + this theme, so a PARTIAL theme -- one that sets
      # a background without carrying a base theme -- is only half the story: the
      # elements it leaves out come from the active default. Resolve against that
      # default first, or a theme setting nothing but a dark plot.background looks
      # dark while the panel actually drawn is the default's light grey (and a
      # globally theme_set() dark default looks light). Anything that is not a
      # theme at all (NULL, a stray value, a function returning one) is ignored
      # when the plot is assembled, so what gets drawn is the active default on
      # its own -- read that, rather than falling through to the bare page.
      th <- if (inherits(th, "theme")) ggplot2::theme_get() + th else ggplot2::theme_get()
      # What a cell actually sits on, painted in the order the device paints it:
      # the white page, then plot.background, then panel.background. Compositing
      # rather than picking one element is what makes a partly transparent
      # background come out as the color the eye sees.
      .composite_over(
        .theme_element_fill(th, "panel.background"),
        .composite_over(.theme_element_fill(th, "plot.background"), "white")
      )
    },
    error = function(e) NULL
  )
  if (is.null(fill)) {
    return(TRUE)
  }
  lum <- tryCatch(.relative_luminance(fill), error = function(e) NA_real_)
  is.na(lum) || lum > threshold
}

# The fill of one theme element, exactly as the theme gives it (alpha included):
# resolved through the theme's inheritance where that works (a fill set on `rect`
# reaches `panel.background` that way), and read off the element directly
# otherwise. NULL when the element paints nothing usable -- blank, missing, NA, or
# not a single color.
.theme_element_fill <- function(th, element) {
  fill <- tryCatch(ggplot2::calc_element(element, th)$fill, error = function(e) NULL)
  if (is.null(fill)) {
    fill <- tryCatch(th[[element]]$fill, error = function(e) NULL)
  }
  if (is.null(fill) || length(fill) != 1L || is.na(fill)) {
    return(NULL)
  }
  fill
}

# Paint `fill` onto `backdrop` and return the resulting color. A fill that is
# absent or fully transparent paints nothing, so the backdrop shows through
# unchanged -- theme_void's plot.background is literally transparent black, which
# taken at face value would be the darkest background there is. A partly
# transparent fill is blended, so a 90%-opaque near-black panel is read as the
# near-black the eye sees rather than discarded for not being opaque.
.composite_over <- function(fill, backdrop) {
  if (is.null(fill)) {
    return(backdrop)
  }
  rgba <- tryCatch(grDevices::col2rgb(fill, alpha = TRUE)[, 1], error = function(e) NULL)
  if (is.null(rgba) || anyNA(rgba) || rgba[4] == 0) {
    return(backdrop)
  }
  if (rgba[4] == 255) {
    return(fill)
  }
  under <- tryCatch(grDevices::col2rgb(backdrop)[, 1], error = function(e) c(255, 255, 255))
  opacity <- rgba[4] / 255
  blended <- rgba[1:3] * opacity + under * (1 - opacity)
  grDevices::rgb(blended[1], blended[2], blended[3], maxColorValue = 255)
}


# hc.order correlation matrix. Returns the whole hclust object (its $order gives
# the reordering; the tree itself is needed to draw cluster rectangles, hc.rect).
.hc_cormat_order <- function(cormat, hc.method = "complete") {
  dd <- stats::as.dist((1 - cormat) / 2)
  stats::hclust(dd, method = hc.method)
}

# Contiguous block bounds (in dendrogram-order axis positions 1..n) for the k
# clusters of an hclust tree. cutree() labels each variable with its cluster;
# reindexing by hc$order puts them in the same order as the plotted axes, where
# each cluster is guaranteed to be a contiguous run (a property of the dendrogram
# leaf order), so rle() gives exactly k blocks. Returns lo/hi position of each.
.hc_rect_bounds <- function(hc, k) {
  cl <- stats::cutree(hc, k = k)[hc$order]
  runs <- rle(cl)
  hi <- cumsum(runs$lengths)
  lo <- hi - runs$lengths + 1L
  list(lo = lo, hi = hi)
}

.no_panel <- function() {
  ggplot2::theme(
    axis.title.x = ggplot2::element_blank(),
    axis.title.y = ggplot2::element_blank()
  )
}


# Convert a tbl to matrix
.tibble_to_matrix <- function(x) {
  x <- as.data.frame(x)
  rownames(x) <- x[, 1]
  x <- x[, -1]
  as.matrix(x)
}

# Mixed layout (P0.1, issue #85): a different glyph per triangle, requested via
# lower.method / upper.method; the diagonal always shows the variable names. The
# single-method path must stay byte-identical (that is covered by test-structure.R
# and the byte-identity harness); here we lock the structure of the mixed plot.

corr <- round(cor(mtcars), 1)
p.mat <- cor_pmat(mtcars)
n <- ncol(mtcars)
tri <- n * (n - 1) / 2

geoms <- function(p) unname(vapply(p$layers, function(l) class(l$geom)[1], character(1)))
has_scale <- function(p, aes) {
  any(vapply(p$scales$scales, function(s) aes %in% s$aesthetics, logical(1)))
}
axis_labels <- function(p, which) {
  b <- ggplot2::ggplot_build(p)
  b$layout$panel_params[[1]][[which]]$get_labels()
}

test_that("no method.* argument leaves the single-method path untouched", {
  # mixed mode must NOT fire when the per-region args are absent
  base <- ggcorrplot(corr)
  expect_equal(geoms(base), "GeomTile")
  expect_false(has_scale(base, "colour"))
})

test_that("lower.method + upper.method draws a glyph per triangle plus a name diagonal", {
  p <- ggcorrplot(corr, lower.method = "number", upper.method = "circle")
  # lower numbers (text), upper circles (points), diagonal names (text)
  expect_equal(geoms(p), c("GeomText", "GeomPoint", "GeomText"))
  # each region holds the right number of cells
  rows <- vapply(ggplot2::ggplot_build(p)$data, nrow, integer(1))
  expect_equal(sort(rows), sort(c(tri, tri, n))) # two triangles + diagonal
})

test_that("the two axes share one variable order so the diagonal is a straight line", {
  p <- ggcorrplot(corr, lower.method = "number", upper.method = "circle")
  expect_identical(axis_labels(p, "x"), axis_labels(p, "y"))
  expect_identical(axis_labels(p, "x"), colnames(corr))
})

test_that("a 'number' region adds a colour scale with its guide suppressed", {
  p <- ggcorrplot(corr, lower.method = "number", upper.method = "circle")
  expect_true(has_scale(p, "colour"))
  # the fill scale (from the circle region) is still present for the legend
  expect_true(has_scale(p, "fill"))
})

test_that("a numbers-only mixed plot keeps a legend for its value colours", {
  colour_scale <- function(p) {
    s <- p$scales$scales
    s[[which(vapply(s, function(x) "colour" %in% x$aesthetics, logical(1)))]]
  }
  # both triangles numeric: no fill glyph, so the colour scale must carry the
  # legend (named), otherwise the plot would be colour-encoded but legend-less
  nn <- ggcorrplot(corr, lower.method = "number", upper.method = "number")
  expect_equal(colour_scale(nn)$name, "Corr")
  # a fill glyph present: the fill scale carries the legend, colour is redundant
  nc <- ggcorrplot(corr, lower.method = "number", upper.method = "circle")
  expect_s3_class(colour_scale(nc)$name, "waiver")
})

test_that("no 'number' region means no colour scale", {
  p <- ggcorrplot(corr, lower.method = "square", upper.method = "circle")
  expect_false(has_scale(p, "colour"))
  expect_equal(geoms(p), c("GeomTile", "GeomPoint", "GeomText"))
})

test_that("the diagonal shows the variable names in a mixed layout", {
  p <- ggcorrplot(corr, lower.method = "square", upper.method = "circle")
  # the last layer is the diagonal name text, one per variable
  diag_layer <- p$layers[[length(p$layers)]]
  expect_s3_class(diag_layer$geom, "GeomText")
  d <- diag_layer$data
  expect_equal(nrow(d), n)
  expect_true(all(as.character(d$Var1) == as.character(d$Var2)))
})

test_that("an unset triangle inherits the base method", {
  p <- ggcorrplot(corr, upper.method = "circle") # method defaults to square
  # lower triangle should be squares (tiles), upper circles, diagonal names
  expect_true(all(c("GeomTile", "GeomPoint") %in% geoms(p)))
})

test_that("mixed mode forces the full matrix regardless of type", {
  p <- ggcorrplot(corr, lower.method = "number", upper.method = "circle", type = "lower")
  rows <- sum(vapply(ggplot2::ggplot_build(p)$data, nrow, integer(1)))
  expect_equal(rows, n * n) # full matrix, not just a triangle
})

test_that("mixed labels format like the coefficient labels do", {
  # the number glyph reuses .format_coef, so nsmall / leading.zero apply
  p <- ggcorrplot(corr, lower.method = "number", nsmall = 2L)
  lower <- ggplot2::ggplot_build(p)$data[[1]]
  expect_true(all(grepl("\\.[0-9]{2}$", lower$label)))
})

test_that("a mixed layout requires a square matrix", {
  ns <- cor(mtcars)[1:3, 1:5]
  expect_error(ggcorrplot(ns, lower.method = "number"), "square")
})

test_that("a mixed layout requires matching row and column names (no silent mislabel)", {
  m <- round(cor(mtcars[, 1:4]), 1)
  colnames(m) <- c("w", "x", "y", "z") # square, but names differ from rownames
  expect_error(
    ggcorrplot(m, lower.method = "number", upper.method = "circle"),
    "matching row and column names"
  )
  # a genuine correlation matrix (rownames == colnames) is unaffected
  expect_s3_class(
    ggplot2::ggplotGrob(ggcorrplot(round(cor(mtcars[, 1:4]), 1),
      lower.method = "number", upper.method = "circle"
    )),
    "gtable"
  )
})

test_that("per-triangle methods are validated", {
  expect_error(ggcorrplot(corr, lower.method = "pie"))
  expect_error(ggcorrplot(corr, upper.method = "wedge"))
})

test_that("a number region shows the true coefficient, never a blanked 0, under insig='blank'", {
  # regression: the shared insig='blank' zeroing must not reach the number glyph,
  # or non-significant cells would print a wrong "0" instead of their coefficient
  suppressMessages(
    p <- ggcorrplot(corr,
      lower.method = "number", upper.method = "circle",
      p.mat = p.mat, insig = "blank"
    )
  )
  lower <- ggplot2::ggplot_build(p)$data[[1]]
  expect_false(any(lower$label == "0"))
  # the labels are the real rounded coefficients
  expect_true(all(grepl("^-?[01]?\\.[0-9]+$|^-?1$", lower$label)))
})

test_that("mixed mode messages when it ignores single-method overlay arguments", {
  expect_message(
    ggcorrplot(corr, lower.method = "number", p.mat = p.mat),
    "mixed layout"
  )
  expect_message(
    ggcorrplot(corr, lower.method = "number", lab = TRUE),
    "mixed layout"
  )
  # no message for a clean mixed call that sets no overlay arguments
  expect_no_message(
    ggcorrplot(corr, lower.method = "number", upper.method = "circle")
  )
})

test_that("numeric-looking, non-sorted dimnames do not scramble the mixed grid (#37)", {
  # reshape2::melt type-converts numeric names to their VALUES; the region split
  # and axes must key off grid POSITION, not the value, or the diagonal bends
  m <- round(cor(mtcars[, 1:5]), 1)
  dimnames(m) <- list(c("50", "10", "30", "20", "40"), c("50", "10", "30", "20", "40"))
  p <- ggcorrplot(m, lower.method = "number", upper.method = "circle")
  # the axes keep the matrix order (not sorted numerically)
  expect_identical(axis_labels(p, "x"), c("50", "10", "30", "20", "40"))
  expect_identical(axis_labels(p, "x"), axis_labels(p, "y"))
  # the diagonal "name" cells sit exactly on x == y
  b <- ggplot2::ggplot_build(p)
  diag_d <- p$layers[[3]]$data
  xpos <- match(as.character(diag_d$Var1), axis_labels(p, "x"))
  ypos <- match(as.character(diag_d$Var2), axis_labels(p, "y"))
  expect_equal(xpos, ypos)
})

test_that("as.is = TRUE works in a mixed layout without warning or scrambling", {
  m <- round(cor(mtcars[, 1:5]), 1)
  expect_no_warning(
    p <- ggcorrplot(m, lower.method = "number", upper.method = "circle", as.is = TRUE)
  )
  k <- ncol(m)
  rows <- sort(vapply(ggplot2::ggplot_build(p)$data, nrow, integer(1)))
  expect_equal(rows, sort(c(k, k * (k - 1) / 2, k * (k - 1) / 2)))
})

test_that("the mixed arguments do not break partial matching of existing arguments", {
  # lower.method/upper.method deliberately avoid the prefixes of commonly-used
  # existing arguments, so their abbreviations keep resolving uniquely:
  # `meth`/`m` still reach `method`, and `d`/`di` still reach `digits`.
  expect_s3_class(ggcorrplot(corr, meth = "circle")$layers[[1]]$geom, "GeomPoint")
  expect_s3_class(ggcorrplot(corr, m = "circle")$layers[[1]]$geom, "GeomPoint")
  # `digits` abbreviations must still work (no `diag.*` formal shadows them)
  expect_silent(ggcorrplot(corr, d = 2))
  expect_silent(ggcorrplot(corr, di = 2))
})

test_that("a fully-NA variable is not resurrected as an empty band in a mixed layout", {
  # the mixed layout pins the discrete axes with drop = FALSE, so a variable that
  # is entirely NA (absent after na.rm melt) must be dropped from the axis levels
  # rather than shown as an empty labelled row/column
  m <- round(cor(mtcars[, 1:4]), 1)
  m[2, ] <- NA
  m[, 2] <- NA
  p <- ggcorrplot(m, lower.method = "number", upper.method = "circle")
  labs <- ggplot2::ggplot_build(p)$layout$panel_params[[1]]$x$get_labels()
  present <- colnames(m)[colSums(!is.na(m)) > 0]
  expect_setequal(labs, present)
  expect_false(colnames(m)[2] %in% labs) # the all-NA variable is gone
  # both axes must drop it together; pinning only one leaves a phantom band on the
  # other, and a continuous axis would still report matching break labels
  expect_identical(axis_labels(p, "x"), axis_labels(p, "y"))
})

test_that("an unnamed matrix still draws a discrete positional axis in a mixed layout", {
  m <- round(cor(mtcars[, 1:4]), 1)
  dimnames(m) <- NULL
  p <- ggcorrplot(m, lower.method = "number", upper.method = "circle")
  expect_s3_class(p$data$Var1, "factor")
  # Var2 too: left as the integers melt produces, the y axis silently goes
  # continuous while its break labels still read "1", "2", ...
  expect_s3_class(p$data$Var2, "factor")
  expect_s3_class(ggplot2::ggplotGrob(p), "gtable")
})

test_that("mixed composes with hc.order without error and stays full", {
  p <- ggcorrplot(corr, lower.method = "number", upper.method = "circle", hc.order = TRUE)
  expect_s3_class(ggplot2::ggplotGrob(p), "gtable")
  # reordered axis is still shared between x and y
  expect_identical(axis_labels(p, "x"), axis_labels(p, "y"))
})

test_that("a ragged NA pattern keeps both axes on one matrix-ordered scale", {
  # melt(na.rm = TRUE) drops NA cells, so the order the variables first APPEAR in
  # the melted frame is not the matrix order once the NA pattern is ragged. Taking
  # the two axes independently from that appearance order put them out of step and
  # landed the diagonal name region on cells that are not self-pairs -- a silent
  # mislabel on a plot that renders cleanly. Both axes must stay in matrix order.
  m <- round(cor(mtcars)[1:4, 1:4], 2)
  m["cyl", "mpg"] <- NA
  m["mpg", "cyl"] <- NA
  p <- ggcorrplot(m, lower.method = "number", upper.method = "circle")
  expect_identical(axis_labels(p, "x"), axis_labels(p, "y"))
  expect_identical(axis_labels(p, "x"), colnames(m))
})

test_that("the mixed diagonal names only ever sit on genuine self-pairs", {
  # the failure this guards is positional, so assert on the drawn cells: every
  # label in the name layer must sit where its own row and column meet.
  expect_diagonal_is_self_paired <- function(m) {
    p <- ggcorrplot(m, lower.method = "number", upper.method = "circle")
    b <- ggplot2::ggplot_build(p)
    name_layer <- b$data[[length(b$data)]] # regions are added lower, upper, diagonal
    xl <- axis_labels(p, "x")
    yl <- axis_labels(p, "y")
    expect_identical(xl[name_layer$x], yl[name_layer$y])
    expect_identical(as.character(name_layer$label), xl[name_layer$x])
  }
  # a pair of variables that never co-occur -> one NA cell per triangle
  d <- mtcars[, 1:4]
  d[1:16, 1] <- NA
  d[17:32, 2] <- NA
  expect_diagonal_is_self_paired(round(suppressWarnings(
    cor(d, use = "pairwise.complete.obs")
  ), 2))
  # a zero-variance column -> cor() returns NA for every pair involving it
  dc <- mtcars[, 1:4]
  dc[, 2] <- 1
  expect_diagonal_is_self_paired(suppressWarnings(round(cor(dc), 2)))
  # an asymmetric NA pattern (row blanked, column kept)
  ma <- round(cor(mtcars[, 1:5]), 2)
  ma[1, ] <- NA
  expect_diagonal_is_self_paired(ma)
  # a whole column blank, so the two axes see DIFFERENT variable sets: Var1 still
  # meets all three, Var2 only the first two. Every other fixture here is
  # symmetric, where each axis's appearance order happens to match matrix order --
  # so only this one can catch one axis being re-levelled without the other.
  mc <- matrix(
    c(1, 0.5, NA, 0.5, 1, NA, 0.3, 0.4, NA), 3, 3,
    byrow = TRUE, dimnames = list(c("A", "B", "C"), c("A", "B", "C"))
  )
  expect_diagonal_is_self_paired(mc)
  p <- ggcorrplot(mc, lower.method = "number", upper.method = "circle")
  expect_identical(axis_labels(p, "x"), axis_labels(p, "y"))
  expect_identical(axis_labels(p, "x"), colnames(mc))
})

test_that("an unnamed ragged matrix orders the mixed axes numerically, not by appearance", {
  m <- round(cor(mtcars)[1:4, 1:4], 2)
  m[2, 1] <- NA
  m[1, 2] <- NA
  dimnames(m) <- NULL
  p <- ggcorrplot(m, lower.method = "number", upper.method = "circle")
  expect_identical(axis_labels(p, "x"), axis_labels(p, "y"))
  expect_identical(axis_labels(p, "x"), as.character(1:4))
})

test_that("tl.col and tl.cex reach the mixed diagonal names", {
  # tl.col was once accepted and silently dropped (#44); the mixed name region
  # takes its colour and size from these arguments, so pin them.
  p <- ggcorrplot(corr, lower.method = "number", upper.method = "circle")
  expect_identical(p$layers[[3]]$aes_params$colour, "black")
  expect_equal(p$layers[[3]]$aes_params$size, 12 / 3)
  q <- ggcorrplot(corr,
    lower.method = "number", upper.method = "circle",
    tl.col = "steelblue", tl.cex = 18
  )
  expect_identical(q$layers[[3]]$aes_params$colour, "steelblue")
  expect_equal(q$layers[[3]]$aes_params$size, 18 / 3)
})

# Regression tests for the tl.col argument (#44)

test_that("tl.col colours the axis text on both axes (#44)", {
  corr <- round(cor(mtcars), 1)
  g <- ggcorrplot(corr, tl.col = "red")
  expect_equal(ggplot2::calc_element("axis.text.x", g$theme)$colour, "red")
  expect_equal(ggplot2::calc_element("axis.text.y", g$theme)$colour, "red")
})

test_that("tl.col defaults to inheriting the theme colour, not a forced black (#44 no-regression)", {
  corr <- round(cor(mtcars), 1)
  default_col <- ggplot2::calc_element("axis.text.x", ggcorrplot(corr)$theme)$colour
  theme_col   <- ggplot2::calc_element("axis.text", ggplot2::theme_minimal())$colour
  expect_equal(default_col, theme_col)
})

test_that("cor_pmat on complete data is unchanged (no NA, symmetric, zero diag)", {
  pm <- cor_pmat(mtcars)
  expect_false(anyNA(pm))
  expect_equal(diag(pm), rep(0, ncol(mtcars)), ignore_attr = TRUE)
  expect_equal(pm, t(pm))
})

test_that("cor_pmat returns NA for an uncomputable pair instead of erroring", {
  # A and D never co-occur (complementary missingness) -> no overlapping obs
  d <- data.frame(
    A = c(1, 2, 3, 4, 5, NA, NA, NA, NA, NA),
    B = c(2, 4, 6, 8, 10, 1, 2, 3, 4, 5),
    C = c(5, 3, 6, 2, 8, 1, 9, 4, 7, 0),
    D = c(NA, NA, NA, NA, NA, 5, 4, 3, 2, 1)
  )
  pm <- expect_no_error(cor_pmat(d))
  expect_true(is.na(pm["A", "D"]))
  expect_true(is.na(pm["D", "A"]))
  # computable pairs still get a p-value
  expect_false(is.na(pm["B", "C"]))
  # diagonal and symmetry preserved
  expect_equal(diag(pm), rep(0, 4), ignore_attr = TRUE)
  expect_equal(pm, t(pm))
})

test_that("cor_pmat does not swallow genuine errors into NA", {
  # a bad method= must still error loudly, not silently return an all-NA matrix
  expect_error(cor_pmat(mtcars, method = "bogus"))
  # a non-numeric column must still error, not become NA
  dd <- data.frame(a = 1:10, b = letters[1:10], c = rnorm(10))
  expect_error(cor_pmat(dd))
})

test_that("cor_pmat still forwards extra args to cor.test", {
  pearson <- cor_pmat(mtcars)
  # method = "spearman" is forwarded to cor.test (ties warning is expected on
  # mtcars and not what we are testing here).
  spearman <- suppressWarnings(cor_pmat(mtcars, method = "spearman"))
  expect_false(anyNA(spearman))
  expect_equal(spearman, t(spearman))
  # forwarding actually took effect: spearman p-values differ from pearson
  expect_false(isTRUE(all.equal(pearson, spearman)))
})

# Tests for the nsmall (#43) and legend.limit (#54) arguments

.text_labels <- function(g) {
  i <- which(vapply(g$layers, function(l) inherits(l$geom, "GeomText"), logical(1)))
  g$layers[[i[1]]]$aes_params$label
}

test_that("nsmall keeps trailing zeros in labels; default is unchanged (#43)", {
  corr <- round(cor(mtcars), 1)
  d0 <- .text_labels(ggcorrplot(corr, lab = TRUE))              # default nsmall = 0
  d2 <- .text_labels(ggcorrplot(corr, lab = TRUE, nsmall = 2))  # two decimals
  # nsmall = 2 formats to exactly two decimals (e.g. 0.70, 1.00)
  expect_type(d2, "character")
  expect_true(all(grepl("^-?[0-9]+\\.[0-9]{2}$", d2)))
  expect_true(any(d2 %in% c("1.00", "0.70", "-0.70", "-0.90")))
  # default keeps the plain rounded values (no forced trailing zeros)
  expect_false(any(as.character(d0) %in% c("1.00", "0.70")))
})

test_that("legend.limit controls the fill scale range; default is unchanged (#54)", {
  cv <- cov(mtcars)
  grey <- function(...) {
    sum(ggplot2::ggplot_build(ggcorrplot(cv, ...))$data[[1]]$fill == "grey50")
  }
  # default limit c(-1, 1) clips covariance values out of range -> grey cells
  expect_gt(grey(), 0)
  # NULL uses the data range -> nothing clipped
  expect_equal(grey(legend.limit = NULL), 0L)
})

# Tests for the sig.stars argument (#26, #41, #50)

.text_labels <- function(g) {
  i <- which(vapply(g$layers, function(l) inherits(l$geom, "GeomText"), logical(1)))
  g$layers[[i[1]]]$aes_params$label
}
.n_crosses <- function(g) {
  b <- ggplot2::ggplot_build(g)$data
  sum(vapply(b, function(d) {
    if ("shape" %in% names(d) && nrow(d) > 0 && all(d$shape == 4)) nrow(d) else 0L
  }, 0L))
}

test_that("sig.stars appends significance stars to labels; default off is unchanged (#26, #41)", {
  corr <- round(cor(mtcars), 1)
  p <- cor_pmat(mtcars)

  # default: no stars appended
  d0 <- .text_labels(ggcorrplot(corr, p.mat = p, lab = TRUE))
  expect_false(any(grepl("[*]", d0)))

  # sig.stars = TRUE: stars on significant cells, bare number on non-significant
  d1 <- .text_labels(ggcorrplot(corr, p.mat = p, lab = TRUE, sig.stars = TRUE))
  expect_true(any(grepl("[*]{3}$", d1)))          # p < 0.001
  expect_true(any(grepl("(?<![*])[*]$", d1, perl = TRUE)))  # single star
  expect_true(any(grepl("^-?[0-9.]+$", d1)))      # non-significant: bare number
})

test_that("sig.stars suppresses the insig = 'pch' crosses (#33 stays available by default)", {
  corr <- round(cor(mtcars), 1)
  p <- cor_pmat(mtcars)
  # default (pch) draws crosses; sig.stars conveys significance instead
  expect_gt(.n_crosses(ggcorrplot(corr, p.mat = p, lab = TRUE)), 0)
  expect_equal(.n_crosses(ggcorrplot(corr, p.mat = p, lab = TRUE, sig.stars = TRUE)), 0)
})

test_that("cor_pmat default use is unchanged (byte-identical)", {
  # the default 'pairwise.complete.obs' must reproduce the historical output
  expect_identical(cor_pmat(mtcars), cor_pmat(mtcars, use = "pairwise.complete.obs"))
  expect_false(anyNA(cor_pmat(mtcars)))
  # partial-NA but every pair still computable: default must not blank anything new
  set.seed(1)
  m <- mtcars
  m[cbind(sample(32, 6), sample(11, 6))] <- NA
  pm <- cor_pmat(m)
  expect_equal(pm, t(pm))
})

test_that("use = 'everything' aligns the NA pattern with cor()'s default", {
  d <- data.frame(
    A = c(1, 2, 3, 4, 5, NA, NA, NA, NA, NA),
    B = c(2, 4, 6, 8, 10, 1, 2, 3, 4, 5),
    C = c(5, 3, 6, 2, 8, 1, 9, 4, 7, 0),
    D = c(NA, NA, NA, NA, NA, 5, 4, 3, 2, 1)
  )
  # cor() default is use = "everything": NA wherever a column has any NA
  expect_identical(is.na(cor_pmat(d, use = "everything")), is.na(cor(d)))
  # pairs where both columns are complete still get a real p-value
  expect_false(is.na(cor_pmat(d, use = "everything")["B", "C"]))
  # symmetric, zero diagonal preserved
  pm <- cor_pmat(d, use = "everything")
  expect_equal(pm, t(pm))
  expect_equal(diag(pm), rep(0, 4), ignore_attr = TRUE)
})

test_that("use is restricted to the two safe values", {
  d <- data.frame(a = c(1, 2, 3, NA), b = c(4, 3, 2, 1), c = c(1, 1, 2, 3))
  # listwise options would make the p-value and the coefficient disagree; rejected
  expect_error(cor_pmat(d, use = "complete.obs"))
  expect_error(cor_pmat(d, use = "na.or.complete"))
  # all.obs would only ever error on NA data; rejected
  expect_error(cor_pmat(d, use = "all.obs"))
})

test_that("the uncomputable-pair fix still holds under the default use", {
  # two variables that never co-occur -> NA, no crash (regression guard for #51/#78)
  d <- data.frame(
    A = c(1, 2, 3, 4, 5, NA, NA, NA, NA, NA),
    B = c(2, 4, 6, 8, 10, 1, 2, 3, 4, 5),
    D = c(NA, NA, NA, NA, NA, 5, 4, 3, 2, 1)
  )
  pm <- expect_no_error(cor_pmat(d))
  expect_true(is.na(pm["A", "D"]))
})

# Structural contract of the plot ggcorrplot() builds.
#
# The vdiffr snapshots in test-vdiffr.R are skip_on_ci() and skip_on_cran(), so
# they never run outside a maintainer's laptop. The assertions below are the
# cross-cutting safety net that DOES run on CI and CRAN: layer composition,
# built-data shape, the melt contract, scale semantics, and the coordinate
# system. Individual arguments are covered by their own test files; this file
# locks in how the pieces fit together, which is what a refactor of the
# transform-then-plot pipeline is liable to break.
#
# Values here were read off the current implementation, not assumed. Where a
# number is derived (e.g. 11 * 11 cells), it is written as the expression.

corr <- round(cor(mtcars), 1)
p.mat <- cor_pmat(mtcars)
n <- ncol(mtcars) # 11

geoms <- function(p) unname(vapply(p$layers, function(l) class(l$geom)[1], character(1)))
layer_rows <- function(p) unname(vapply(ggplot2::ggplot_build(p)$data, nrow, integer(1)))
fill_scale <- function(p) {
  s <- p$scales$scales
  i <- which(vapply(s, function(x) "fill" %in% x$aesthetics, logical(1)))
  if (length(i) != 1L) stop("expected exactly one fill scale, found ", length(i))
  s[[i]]
}


# ---- layer composition -------------------------------------------------------

test_that("the default plot is a single tile layer over every cell", {
  p <- ggcorrplot(corr)
  expect_equal(geoms(p), "GeomTile")
  expect_equal(layer_rows(p), n * n)
})

test_that("positional arguments still bind as before (new args are appended, not inserted)", {
  # the mixed-layout args were added at the END of the signature, so a positional
  # `type` call must keep working: ggcorrplot(corr, <method>, <type>)
  p <- ggcorrplot(corr, "circle", "lower")
  expect_equal(geoms(p), "GeomPoint")
  expect_equal(layer_rows(p), n * (n - 1) / 2) # lower triangle, off-diagonal
  full <- ggcorrplot(corr, "circle", "full")
  expect_equal(layer_rows(full), n * n)
})

test_that("method = 'circle' swaps the tile layer for a sized point layer", {
  p <- ggcorrplot(corr, method = "circle")
  expect_equal(geoms(p), "GeomPoint")
  expect_equal(layer_rows(p), n * n)
  # shape 21 is what makes the point fillable and outline-able
  expect_identical(p$layers[[1]]$aes_params$shape, 21)
  # size is mapped, and its legend suppressed
  expect_true("size" %in% names(p$layers[[1]]$mapping))
})

test_that("lab = TRUE adds a text layer on top of the glyph layer, in that order", {
  p <- ggcorrplot(corr, lab = TRUE)
  expect_equal(geoms(p), c("GeomTile", "GeomText"))
  expect_equal(layer_rows(p), c(n * n, n * n))
})

test_that("insig = 'pch' adds a point layer holding exactly the non-significant cells", {
  p <- ggcorrplot(corr, p.mat = p.mat)
  expect_equal(geoms(p), c("GeomTile", "GeomPoint"))
  # the pch layer marks p > sig.level, and nothing else
  expect_equal(layer_rows(p)[2], sum(p.mat > 0.05))
})

test_that("insig = 'blank' adds no layer -- it zeroes the fill value instead", {
  p <- ggcorrplot(corr, p.mat = p.mat, insig = "blank")
  expect_equal(geoms(p), "GeomTile")
  expect_equal(sum(p$data$value == 0), sum(p.mat > 0.05))
})

test_that("sig.stars suppresses the pch layer rather than drawing both", {
  p <- ggcorrplot(corr, p.mat = p.mat, sig.stars = TRUE, lab = TRUE)
  expect_equal(geoms(p), c("GeomTile", "GeomText"))
  expect_false("GeomPoint" %in% geoms(p))
})

test_that("lab and insig = 'pch' coexist as three layers", {
  p <- ggcorrplot(corr, p.mat = p.mat, lab = TRUE, insig = "pch")
  expect_equal(geoms(p), c("GeomTile", "GeomText", "GeomPoint"))
})


# ---- triangle and diagonal selection ----------------------------------------

test_that("type and show.diag select exactly the expected number of cells", {
  # off-diagonal cells of one triangle
  tri <- n * (n - 1) / 2
  expect_equal(layer_rows(ggcorrplot(corr, type = "lower")), tri)
  expect_equal(layer_rows(ggcorrplot(corr, type = "upper")), tri)
  expect_equal(layer_rows(ggcorrplot(corr, type = "lower", show.diag = TRUE)), tri + n)
  expect_equal(layer_rows(ggcorrplot(corr, type = "upper", show.diag = TRUE)), tri + n)
  expect_equal(layer_rows(ggcorrplot(corr, type = "full")), n * n)
  expect_equal(layer_rows(ggcorrplot(corr, show.diag = FALSE)), n * n - n)
})

test_that("show.diag defaults to TRUE for type = 'full' and FALSE otherwise", {
  expect_equal(layer_rows(ggcorrplot(corr)),
               layer_rows(ggcorrplot(corr, show.diag = TRUE)))
  expect_equal(layer_rows(ggcorrplot(corr, type = "lower")),
               layer_rows(ggcorrplot(corr, type = "lower", show.diag = FALSE)))
})

test_that("the lower triangle keeps cells below the diagonal, the upper above", {
  lo <- ggcorrplot(corr, type = "lower")$data
  up <- ggcorrplot(corr, type = "upper")$data
  # levels run in matrix row order, so column index < row index is the lower half
  expect_true(all(as.integer(lo$Var1) > as.integer(lo$Var2)))
  expect_true(all(as.integer(up$Var1) < as.integer(up$Var2)))
})


# ---- the melt contract -------------------------------------------------------

test_that("the plot data carries the documented columns", {
  d <- ggcorrplot(corr)$data
  expect_true(all(c("Var1", "Var2", "value", "pvalue", "signif", "abs_corr") %in% names(d)))
})

test_that("Var1/Var2 are factors whose levels follow matrix row order, not alphabetical", {
  d <- ggcorrplot(corr)$data
  expect_s3_class(d$Var1, "factor")
  expect_identical(levels(d$Var1), colnames(corr))
  expect_identical(levels(d$Var2), colnames(corr))
  # mtcars is not alphabetically ordered -- guards against a silent sort
  expect_false(identical(levels(d$Var1), sort(colnames(corr))))
})

test_that("as.is = TRUE keeps the axis variables in matrix order (as a factor)", {
  # as.is passes through to reshape2::melt, but the axis is then coerced to a
  # factor in matrix (row/column) order so the display order does not depend on
  # how melt happened to render the names (#37)
  d <- ggcorrplot(corr, as.is = TRUE)$data
  expect_s3_class(d$Var1, "factor")
  expect_identical(levels(d$Var1), colnames(corr))
})

test_that("abs_corr is 10x the absolute correlation (drives circle size)", {
  d <- ggcorrplot(corr)$data
  expect_equal(d$abs_corr, abs(d$value) * 10)
})

test_that("p-values are joined by cell name, not by row position", {
  # shuffling p.mat's rows/cols must not change which p-value lands on which cell
  shuffled <- p.mat[rev(seq_len(n)), rev(seq_len(n))]
  a <- ggcorrplot(corr, p.mat = p.mat)$data
  b <- ggcorrplot(corr, p.mat = shuffled)$data
  key <- function(d) paste(d$Var1, d$Var2)
  expect_equal(a$pvalue[order(key(a))], b$pvalue[order(key(b))])
})


# ---- scales ------------------------------------------------------------------

test_that("there is exactly one fill scale, spanning [-1, 1] by default", {
  s <- fill_scale(ggcorrplot(corr))
  expect_equal(s$limits, c(-1, 1))
})

test_that("the default 3-colour palette anchors low/mid/high at -1/0/+1", {
  # class() cannot distinguish gradient2 from gradientn -- both are
  # "ScaleContinuous". Sampling the scale's own mapping can.
  s <- fill_scale(ggcorrplot(corr))
  expect_equal(s$map(0), "#FFFFFF")   # mid = "white"
  expect_equal(s$map(-1), "#0000FF")  # low = "blue"
  expect_equal(s$map(1), "#FF0000")   # high = "red"
})

test_that("the 3-colour path is genuinely DIVERGING: the mid colour stays pinned at zero", {
  # Careful: over the symmetric default limits c(-1, 1), scale_fill_gradient2()
  # and scale_fill_gradientn() produce IDENTICAL colours at every point, so
  # anchor checks alone cannot tell them apart. Only an asymmetric limit
  # separates them -- gradient2 holds the mid colour at midpoint = 0, while
  # gradientn spreads the palette evenly and puts it at the middle of the range.
  # This is the property that makes the scale correct for sign-at-zero data.
  s <- fill_scale(ggcorrplot(corr, legend.limit = c(-1, 3)))
  expect_equal(s$map(0), "#FFFFFF")            # zero is still white
  expect_false(identical(s$map(1), "#FFFFFF")) # the range midpoint is not
})

test_that("a palette whose length is not 3 spreads colours evenly instead of diverging", {
  s <- fill_scale(ggcorrplot(corr, colors = c("blue", "red")))
  expect_equal(s$map(-1), "#0000FF")
  expect_equal(s$map(1), "#FF0000")
  # the midpoint is NOT forced to a mid colour on this path
  expect_false(identical(s$map(0), "#FFFFFF"))
})

test_that("an 11-colour palette maps zero to its own middle colour, not white", {
  pal <- c("#053061", "#2166AC", "#4393C3", "#92C5DE", "#D1E5F0", "#F7F7F7",
           "#FDDBC7", "#F4A582", "#D6604D", "#B2182B", "#67001F")
  s <- fill_scale(ggcorrplot(corr, colors = pal))
  expect_equal(toupper(s$map(-1)), pal[1])
  expect_equal(toupper(s$map(1)), pal[length(pal)])
})

test_that("legend.limit = NULL lets the scale free itself from [-1, 1]", {
  s <- fill_scale(ggcorrplot(cov(mtcars[, 1:4]), legend.limit = NULL))
  expect_null(s$limits)
})

test_that("method = 'circle' maps sizes into the documented [4, 10] range", {
  # assert on the BUILT sizes rather than on scale internals: the range lives in
  # a closure whose layout is a ggplot2 implementation detail
  p <- ggcorrplot(corr, method = "circle")
  sizes <- ggplot2::ggplot_build(p)$data[[1]]$size
  expect_equal(range(sizes), c(4, 10))
  expect_true(any(vapply(p$scales$scales, function(x) "size" %in% x$aesthetics, logical(1))))
})


# ---- coordinate system -------------------------------------------------------

test_that("coord.fixed toggles the aspect ratio, not the coord class", {
  # in ggplot2 >= 4, coord_fixed() and coord_cartesian() share a class; only
  # $ratio distinguishes them. Assert on $ratio.
  expect_equal(ggcorrplot(corr)$coordinates$ratio, 1)
  expect_null(ggcorrplot(corr, coord.fixed = FALSE)$coordinates$ratio)
})


# ---- ordering ----------------------------------------------------------------

test_that("hc.order reorders the axis away from input order", {
  p <- ggcorrplot(corr, hc.order = TRUE)
  expect_false(identical(levels(p$data$Var1), colnames(corr)))
  expect_setequal(levels(p$data$Var1), colnames(corr))
})

test_that("hc.order clusters on the unrounded matrix (#14)", {
  # rounding before clustering manufactures ties that move the dendrogram. This
  # is invisible on a pre-rounded input, so cluster an UNROUNDED matrix here.
  raw <- cor(mtcars)
  ord <- function(m) hclust(as.dist((1 - m) / 2), method = "complete")$order
  expect_false(identical(ord(raw), ord(round(raw, 1))))
  p <- ggcorrplot(raw, hc.order = TRUE, digits = 1)
  expect_identical(levels(p$data$Var1), rownames(raw)[ord(raw)])
})

test_that("hc.order reorders p.mat in lockstep with corr", {
  p <- ggcorrplot(corr, hc.order = TRUE, p.mat = p.mat)
  d <- p$data
  # every cell's pvalue must still be the p-value of its own (Var1, Var2) pair
  expected <- p.mat[cbind(as.character(d$Var1), as.character(d$Var2))]
  expect_equal(d$pvalue, unname(expected))
})

test_that("sig.level is inclusive: p exactly equal to sig.level counts as significant", {
  # `p <= sig.level`, not `p < sig.level`. The two differ only at the boundary,
  # which real data almost never hits -- so only a constructed p-matrix pins it.
  cm <- matrix(c(1, 0.3, 0.3, 1), 2, dimnames = list(c("a", "b"), c("a", "b")))
  pm <- matrix(c(0, 0.05, 0.05, 0), 2, dimnames = list(c("a", "b"), c("a", "b")))

  d <- ggcorrplot(cm, p.mat = pm)$data
  off <- d[d$Var1 != d$Var2, ]
  expect_true(all(off$signif == 1))

  # and, being significant, such a cell must survive insig = "blank"
  db <- ggcorrplot(cm, p.mat = pm, insig = "blank")$data
  offb <- db[db$Var1 != db$Var2, ]
  expect_true(all(offb$value == 0.3))
})

test_that("significance is tested on unrounded p-values", {
  # a p-value of 0.054 must not round to 0.05 and read as significant
  cm <- matrix(c(1, 0.3, 0.3, 1), 2, dimnames = list(c("a", "b"), c("a", "b")))
  pm <- matrix(c(0, 0.054, 0.054, 0), 2, dimnames = list(c("a", "b"), c("a", "b")))
  d <- ggcorrplot(cm, p.mat = pm)$data
  off <- d[d$Var1 != d$Var2, ]
  expect_true(all(off$signif == 0))
})


# ---- draw-time -----------------------------------------------------------------

test_that("every documented configuration survives a real render, not just a build", {
  # ggplot_build() sails past failures that only surface when grobs are made
  configs <- list(
    ggcorrplot(corr),
    ggcorrplot(corr, method = "circle"),
    ggcorrplot(corr, type = "lower", lab = TRUE),
    ggcorrplot(corr, type = "upper", show.diag = TRUE),
    ggcorrplot(corr, hc.order = TRUE, p.mat = p.mat, insig = "blank"),
    ggcorrplot(corr, p.mat = p.mat, sig.stars = TRUE, lab = TRUE),
    ggcorrplot(corr, colors = c("blue", "red")),
    ggcorrplot(corr, coord.fixed = FALSE, title = "t", show.legend = FALSE)
  )
  for (p in configs) expect_s3_class(ggplot2::ggplotGrob(p), "gtable")
})

# Regression test for hc.order clustering on the unrounded matrix (#14)

test_that("hc.order clusters on the unrounded matrix, not the rounded one (#14)", {
  m <- structure(
    c(1, 0.6063, 0.1987, 0.2749, -0.2482, 0.231,
      0.6063, 1, -0.0788, 0.2389, -0.0252, 0.4772,
      0.1987, -0.0788, 1, 0.7596, 0.3316, -0.445,
      0.2749, 0.2389, 0.7596, 1, 0.8052, 0.5687,
      -0.2482, -0.0252, 0.3316, 0.8052, 1, -0.144,
      0.231, 0.4772, -0.445, 0.5687, -0.144, 1),
    dim = c(6L, 6L),
    dimnames = list(LETTERS[1:6], LETTERS[1:6])
  )
  ord_of <- function(x) stats::hclust(stats::as.dist((1 - x) / 2), method = "complete")$order

  # For this matrix, rounding to 1 digit changes the clustering order.
  expect_false(identical(ord_of(m), ord_of(round(m, 1))))

  # ggcorrplot() must order by the UNROUNDED matrix even with an aggressive
  # digits setting (previously it rounded first, so digits perturbed the order).
  g <- ggcorrplot(m, hc.order = TRUE, digits = 1)
  expect_equal(levels(g$data$Var1), rownames(m)[ord_of(m)])
})

test_that("hc.order is honored for numeric-looking dimnames and as.is (#37)", {
  # reshape2::melt used to type-convert numeric-looking names to a continuous
  # axis sorted by value (and as.is = TRUE to an alphabetical character axis),
  # silently discarding hc.order. The axis is now coerced to a factor in
  # cluster order.
  m <- round(cor(mtcars), 1)
  ord <- function(x) stats::hclust(stats::as.dist((1 - x) / 2))$order

  mn <- m
  dimnames(mn) <- list(as.character(seq_len(ncol(m))), as.character(seq_len(ncol(m))))
  g <- ggcorrplot(mn, hc.order = TRUE)
  expect_s3_class(g$data$Var1, "factor")
  expect_identical(levels(g$data$Var1), as.character(seq_len(ncol(m)))[ord(mn)])
  # not the numeric value order
  expect_false(identical(levels(g$data$Var1), as.character(seq_len(ncol(m)))))

  # as.is = TRUE on ordinary names also follows the clustering, not the alphabet
  ga <- ggcorrplot(m, hc.order = TRUE, as.is = TRUE)
  expect_identical(levels(ga$data$Var1), rownames(m)[ord(m)])
})

test_that("hc.order works for non-canonical numeric names, not just '1'..'n' (#37)", {
  m <- round(cor(mtcars[, 1:5]), 1)
  ord <- function(x) stats::hclust(stats::as.dist((1 - x) / 2))$order
  # names whose string form is not their canonical numeric string: melt would
  # type-convert "01" -> 1 -> "1", so a naive coercion would produce all-NA cells
  for (nms in list(
    c("01", "02", "03", "04", "05"),
    c("1.10", "2.20", "3.30", "4.40", "5.50"),
    c("1e2", "2e2", "3e2", "4e2", "5e2")
  )) {
    mm <- m
    dimnames(mm) <- list(nms, nms)
    d <- ggcorrplot(mm, hc.order = TRUE)$data
    expect_false(anyNA(d$Var1))
    expect_false(anyNA(d$Var2))
    expect_identical(levels(d$Var1), nms[ord(mm)])
  }
})

test_that("duplicated variable names do not crash the plot", {
  m <- round(cor(mtcars[, 1:4]), 1)
  dimnames(m) <- list(c("a", "a", "b", "c"), c("a", "a", "b", "c"))
  expect_s3_class(ggplot2::ggplotGrob(ggcorrplot(m)), "gtable")
})

# Non-square correlation matrix handling (#5, #10)

test_that("non-square matrix plots in full but errors for clustered/triangular layouts", {
  rect <- cor(mtcars[, 1:3], mtcars[, 4:7])   # 3 x 4

  # type = "full" (the default) works for a non-square matrix
  expect_no_error(ggplot2::ggplot_build(ggcorrplot(rect)))

  # hc.order and the triangular layouts require a square matrix -> clear error
  expect_error(ggcorrplot(rect, hc.order = TRUE), "square")
  expect_error(ggcorrplot(rect, type = "lower"), "square")
  expect_error(ggcorrplot(rect, type = "upper"), "square")
})

test_that("square matrices are unaffected by the non-square guard", {
  sq <- round(cor(mtcars), 1)
  expect_no_error(ggplot2::ggplot_build(ggcorrplot(sq, hc.order = TRUE, type = "lower")))
})

# show.diag = FALSE on a non-square matrix must remove genuine self-pairs by NAME,
# not the positional diagonal (which is meaningless for m x n). Previously
# .remove_diag() ran diag(cormat) <- NA, blanking min(m, n) arbitrary cells.
cells <- function(p) ggplot2::ggplot_build(p)$data[[1]]
pairs <- function(p) {
  d <- ggplot2::ggplot_build(p)$plot$data
  paste(d$Var1, d$Var2)
}

test_that("non-square + show.diag = FALSE with disjoint variables removes no cell", {
  rect <- cor(mtcars[, 1:3], mtcars[, 4:7]) # 3 x 4, rows {mpg,cyl,disp} cols {hp,drat,wt,qsec}
  # no row variable is also a column variable -> there are no self-pairs to drop
  expect_equal(nrow(cells(ggcorrplot(rect, show.diag = FALSE))), length(rect)) # all 12 kept
  # every cell present, in particular the positional (1,1) cell mpg~hp
  expect_true("mpg hp" %in% pairs(ggcorrplot(rect, show.diag = FALSE)))
})

test_that("non-square + show.diag = FALSE blanks self-pairs by name, off the positional diagonal", {
  m <- round(cor(mtcars), 1)
  # rows are the LAST three of the five columns, so the self-pairs disp~disp,
  # hp~hp, wt~wt sit at columns 3, 4, 5 -- NOT on the positional diagonal
  sub <- m[c("disp", "hp", "wt"), c("mpg", "cyl", "disp", "hp", "wt")] # 3 x 5
  p <- ggcorrplot(sub, show.diag = FALSE)
  expect_equal(nrow(cells(p)), length(sub) - 3L) # exactly the 3 self-pairs removed
  pr <- pairs(p)
  expect_false(any(c("disp disp", "hp hp", "wt wt") %in% pr)) # self-pairs gone
  expect_true("disp mpg" %in% pr) # the positional (1,1) cell (a cross-pair) survives
})

test_that("non-square + show.diag = TRUE (the default for full) keeps every cell", {
  rect <- cor(mtcars[, 1:3], mtcars[, 4:7])
  expect_equal(nrow(cells(ggcorrplot(rect))), length(rect)) # default show.diag path unchanged
})

test_that("unnamed non-square + show.diag = FALSE keeps the historical positional removal", {
  rect <- cor(mtcars[, 1:3], mtcars[, 4:7]) # 3 x 4
  dimnames(rect) <- NULL
  # no names to match self-pairs by, so the positional diagonal (min(m,n) = 3
  # cells) is removed as before -> 12 - 3 = 9 cells
  expect_equal(nrow(cells(ggcorrplot(rect, show.diag = FALSE))), length(rect) - 3L)
})

# scale.square: size-scaled squares (corrplot-style) for method = "square".
# Default FALSE keeps method = "square" a constant full-cell geom_tile.

corr <- round(cor(mtcars), 1)
geom1 <- function(p) class(p$layers[[1]]$geom)[1]
shape1 <- function(p) p$layers[[1]]$aes_params$shape

test_that("scale.square defaults to FALSE: method = 'square' stays a full tile", {
  p <- ggcorrplot(corr)
  expect_identical(geom1(p), "GeomTile")
  # explicit FALSE == implicit default (byte-identical built data)
  expect_equal(
    ggplot2::ggplot_build(ggcorrplot(corr))$data,
    ggplot2::ggplot_build(ggcorrplot(corr, scale.square = FALSE))$data
  )
})

test_that("scale.square = TRUE draws size-scaled squares (shape 22, sized by |r|)", {
  p <- ggcorrplot(corr, scale.square = TRUE)
  expect_identical(geom1(p), "GeomPoint")
  expect_identical(shape1(p), 22)
  # the point size maps to abs_corr (magnitude), and there is a size scale
  b <- ggplot2::ggplot_build(p)
  expect_true("size" %in% names(b$data[[1]]))
  # stronger correlations -> larger size than weak ones
  pd <- b$plot$data
  szmap <- b$data[[1]]$size
  expect_gt(max(szmap), min(szmap)) # sizes actually vary
})

test_that("scale.square has no effect for method = 'circle'", {
  a <- ggcorrplot(corr, method = "circle")
  b <- ggcorrplot(corr, method = "circle", scale.square = TRUE)
  expect_equal(shape1(a), 21)
  expect_equal(shape1(b), 21) # still circles, unchanged
  expect_equal(
    ggplot2::ggplot_build(a)$data,
    ggplot2::ggplot_build(b)$data
  )
})

test_that("scale.square sizes the square region in a mixed layout", {
  # a mixed layout with a 'square' triangle -> that triangle becomes sized squares
  p <- ggcorrplot(corr, lower.method = "square", upper.method = "number", scale.square = TRUE)
  geoms <- vapply(p$layers, function(l) class(l$geom)[1], "")
  expect_true("GeomPoint" %in% geoms) # the square triangle is now a sized point layer
  sq <- p$layers[[which(geoms == "GeomPoint")[1]]]
  expect_identical(sq$aes_params$shape, 22)
})

# insig = "stars" (P1.1): a standalone significance map -- the SIGNIFICANT cells
# are marked with */**/*** stars, independent of lab. The default insig = "pch"
# is unchanged (covered by test-pmat.R / test-structure.R and the byte-identity
# harness); here we lock the new value.

corr <- round(cor(mtcars), 1)
p.mat <- cor_pmat(mtcars)
n <- ncol(mtcars)

geoms <- function(p) unname(vapply(p$layers, function(l) class(l$geom)[1], character(1)))
star_layer_labels <- function(p) {
  i <- which(geoms(p) == "GeomText")
  ggplot2::ggplot_build(p)$data[[i]]$label
}

test_that("insig = 'stars' adds a text layer of significance stars over the tiles", {
  p <- ggcorrplot(corr, p.mat = p.mat, insig = "stars")
  expect_equal(geoms(p), c("GeomTile", "GeomText"))
})

test_that("stars mark significant cells and leave non-significant cells blank", {
  p <- ggcorrplot(corr, p.mat = p.mat, insig = "stars")
  lbl <- star_layer_labels(p)
  d <- ggplot2::ggplot_build(p)$data[[1]] # tiles carry the p-values? no -- rebuild from p.mat
  # every star string is one of the four valid values
  expect_true(all(lbl %in% c("***", "**", "*", "")))
  # a cell is starred iff its p-value is significant at the corresponding level
  pv <- p.mat[cbind(
    as.character(ggplot2::ggplot_build(p)$plot$data$Var1),
    as.character(ggplot2::ggplot_build(p)$plot$data$Var2)
  )]
  expected <- .sig_stars(unname(pv))
  expect_identical(lbl, expected)
  expect_true(any(lbl == "")) # some non-significant cells exist in mtcars
})

test_that(".sig_stars maps p-values to the documented thresholds", {
  expect_identical(
    .sig_stars(c(0.0005, 0.005, 0.03, 0.2, NA)),
    c("***", "**", "*", "", "")
  )
  # boundaries: cut() is right-closed, so a value exactly on a break falls in the
  # lower (more-significant) bin -- 0.001 -> ***, 0.01 -> **, 0.05 -> *
  expect_identical(.sig_stars(c(0.001, 0.01, 0.05)), c("***", "**", "*"))
  # and just above each break drops a level
  expect_identical(.sig_stars(c(0.0011, 0.011, 0.051)), c("**", "*", ""))
})

test_that("insig = 'stars' needs no lab and does not draw the pch layer", {
  p <- ggcorrplot(corr, p.mat = p.mat, insig = "stars") # lab defaults FALSE
  expect_false("GeomPoint" %in% geoms(p)) # no pch crosses
  # the coefficient labels are NOT shown (lab = FALSE): only the stars text layer
  expect_equal(sum(geoms(p) == "GeomText"), 1)
})

test_that("the default insig ('pch') is unchanged when 'stars' is added to the set", {
  expect_equal(geoms(ggcorrplot(corr, p.mat = p.mat)), c("GeomTile", "GeomPoint"))
  expect_error(ggcorrplot(corr, p.mat = p.mat, insig = "nope"))
})

test_that("the old default vector insig = c('pch', 'blank') still resolves to 'pch'", {
  # adding "stars" to the choice set must not break a caller that passes the
  # previously-documented default vector explicitly: match.arg() only accepts a
  # multi-value arg identical to the full choices, so c("pch", "blank") would
  # error unless we resolve on insig[1]. It must behave exactly like insig = "pch".
  expect_error(ggcorrplot(corr, p.mat = p.mat, insig = c("pch", "blank")), NA)
  a <- ggplot2::ggplot_build(ggcorrplot(corr, p.mat = p.mat, insig = c("pch", "blank")))
  b <- ggplot2::ggplot_build(ggcorrplot(corr, p.mat = p.mat, insig = "pch"))
  expect_equal(a$data, b$data)
})

test_that("insig = 'stars' with sig.stars = TRUE and lab = FALSE still draws the stars", {
  # sig.stars appends stars to the coefficient labels, but those only exist when
  # lab = TRUE; with lab = FALSE the standalone stars must still render so the
  # call is not a bare heatmap.
  p <- ggcorrplot(corr, p.mat = p.mat, insig = "stars", sig.stars = TRUE)
  expect_true("GeomText" %in% geoms(p))
  expect_identical(star_layer_labels(p), .sig_stars(unname(
    p.mat[cbind(
      as.character(ggplot2::ggplot_build(p)$plot$data$Var1),
      as.character(ggplot2::ggplot_build(p)$plot$data$Var2)
    )]
  )))
  # and with lab = TRUE the suffix path draws them, so the standalone layer is
  # suppressed (no double stars): exactly one GeomText, from the labels
  p2 <- ggcorrplot(corr, p.mat = p.mat, insig = "stars", sig.stars = TRUE, lab = TRUE)
  expect_equal(sum(geoms(p2) == "GeomText"), 1)
})

test_that("insig = 'stars' with lab = TRUE appends stars to the labels, no second layer", {
  # lab = TRUE puts the coefficient at the cell center; the stars must be appended
  # to that label (one GeomText: numbers + stars) rather than drawn as a second
  # geom_text overprinting into illegible output.
  p <- ggcorrplot(corr, p.mat = p.mat, insig = "stars", lab = TRUE)
  expect_equal(sum(geoms(p) == "GeomText"), 1L)
  labs <- ggplot2::ggplot_build(p)$data[[which(geoms(p) == "GeomText")]]$label
  # the label carries the number and, on significant cells, the appended stars
  expect_true(any(grepl("[0-9].*\\*", labs)))
  # it equals the sig.stars = TRUE, lab = TRUE label (both are numbers + stars)
  q <- ggcorrplot(corr, p.mat = p.mat, sig.stars = TRUE, lab = TRUE)
  expect_identical(
    ggplot2::ggplot_build(p)$data[[which(geoms(p) == "GeomText")]]$label,
    ggplot2::ggplot_build(q)$data[[which(geoms(q) == "GeomText")]]$label
  )
})

test_that("sig.stars and insig = 'stars' share one star definition", {
  # sig.stars appends the SAME stars to the coefficient labels
  p <- ggcorrplot(corr, p.mat = p.mat, lab = TRUE, sig.stars = TRUE)
  labs <- ggplot2::ggplot_build(p)$data[[2]]$label
  expect_true(any(grepl("\\*", labs)))
})

# The mixed "number" glyph maps the coefficient TEXT onto the fill ramp, which is
# white at zero -- so a near-zero coefficient rendered invisible against the
# panel, and a blank cell in a correlogram reads as removed/non-significant. The
# text ramp is darkened to a legibility floor; the FILL ramp must be untouched.

corr <- round(cor(mtcars[, 1:6]), 2)

relative_luminance <- function(cols) {
  vapply(cols, function(col) {
    chan <- grDevices::col2rgb(col)[, 1] / 255
    chan <- ifelse(chan <= 0.03928, chan / 12.92, ((chan + 0.055) / 1.055)^2.4)
    sum(c(0.2126, 0.7152, 0.0722) * chan)
  }, numeric(1), USE.NAMES = FALSE)
}
contrast_on_white <- function(cols) 1.05 / (relative_luminance(cols) + 0.05)

test_that("the text ramp clears 4.5:1 contrast on white while the input ramp does not", {
  default <- c("blue", "white", "red")
  expect_true(any(contrast_on_white(default) < 4.5)) # white fails, as it must
  expect_true(all(contrast_on_white(ggcorrplot:::.legible_text_colors(default)) >= 4.5))
  for (pal in c("RdBu", "PuOr")) {
    stops <- ggcorrplot:::.ggcorrplot_palette(pal)
    darkened <- ggcorrplot:::.legible_text_colors(stops)
    expect_length(darkened, length(stops))
    expect_true(all(contrast_on_white(darkened) >= 4.5))
  }
})

test_that("a stop already dark enough is returned untouched", {
  # a stop already at or below the cap is untouched, so a saturated dark end of
  # the ramp keeps its exact value and the warm/cool polarity is unchanged.
  expect_identical(ggcorrplot:::.legible_text_colors("blue"), "blue")
  expect_identical(ggcorrplot:::.legible_text_colors("#053061"), "#053061")
  expect_identical(ggcorrplot:::.legible_text_colors("black"), "black")
  darkened <- ggcorrplot:::.legible_text_colors(c("blue", "white", "red"))
  expect_identical(darkened[1], "blue")
  expect_false(identical(darkened[2], "white"))
})

test_that("darkening preserves the sign of each channel difference (hue is kept)", {
  # scaling the linearised channels by a common factor keeps their ratios, so a
  # reddish stop stays reddish and a bluish stop stays bluish.
  for (col in c("#F4A582", "#92C5DE", "#FDDBC7", "#D1E5F0")) {
    before <- grDevices::col2rgb(col)[, 1]
    after <- grDevices::col2rgb(ggcorrplot:::.legible_text_colors(col))[, 1]
    expect_equal(sign(before["red"] - before["blue"]),
                 sign(after["red"] - after["blue"]))
  }
})

test_that("only the mixed number glyph uses the darkened ramp; fill is untouched", {
  fill_of <- function(p) unique(ggplot2::ggplot_build(p)$data[[1]]$fill)
  # a non-mixed plot gains no colour scale at all
  expect_false(any(vapply(
    ggcorrplot(corr)$scales$scales,
    function(s) "colour" %in% s$aesthetics, logical(1)
  )))
  # the square/circle fills are identical with and without a "number" region
  mixed_fills <- fill_of(ggcorrplot(corr, lower.method = "square", upper.method = "circle"))
  expect_true(all(mixed_fills %in% fill_of(ggcorrplot(corr))))
  # and a mixed plot that draws numbers still carries a colour scale for them
  p <- ggcorrplot(corr, lower.method = "number", upper.method = "circle")
  expect_true(any(vapply(p$scales$scales, function(s) "colour" %in% s$aesthetics, logical(1))))
})

test_that("near-zero coefficients are drawn legibly rather than invisibly", {
  set.seed(42)
  x <- matrix(stats::rnorm(300 * 6), 300, 6,
              dimnames = list(NULL, paste0("item", seq_len(6))))
  weak <- round(stats::cor(x), 2)
  expect_true(max(abs(weak[upper.tri(weak)])) < 0.2) # genuinely weak input
  p <- ggcorrplot(weak, lower.method = "number", upper.method = "number")
  drawn <- ggplot2::ggplot_build(p)$data
  number_cols <- unlist(lapply(drawn[seq_len(2)], function(d) d$colour))
  expect_true(all(contrast_on_white(number_cols) >= 4.5))
})

test_that("a partly transparent stop is left alone rather than made opaque", {
  # col2rgb() drops alpha unless asked for it, so darkening a translucent stop
  # would have re-emitted it opaque -- leaving one text layer with mixed alpha
  # while the fill kept a uniform one. Its luminance over the panel also depends
  # on what it is composited with, so the contrast target does not apply.
  translucent <- c("#0000FF80", "#FFFFFF80", "#FF000080")
  expect_identical(ggcorrplot:::.legible_text_colors(translucent), translucent)
  expect_identical(ggcorrplot:::.legible_text_colors("transparent"), "transparent")
  # an explicitly opaque colour is still darkened
  expect_false(identical(ggcorrplot:::.legible_text_colors("#FFFFFFFF"), "#FFFFFFFF"))
  # and the drawn text keeps one uniform alpha across the whole ramp
  p <- ggcorrplot(round(stats::cor(mtcars[, 1:4]), 2),
    lower.method = "number", upper.method = "circle", colors = translucent
  )
  drawn <- ggplot2::ggplot_build(p)$data[[1]]$colour
  expect_length(unique(substr(drawn, 8, 9)), 1L)
})

test_that("the legibility floor applies to a light panel only", {
  # Darkening assumes dark text reads against the panel. On a dark theme the pale
  # middle of the ramp is already the readable end, so darkening it there would
  # bury the text instead -- the ramp is left as given.
  expect_true(ggcorrplot:::.panel_is_light(ggplot2::theme_minimal))
  expect_true(ggcorrplot:::.panel_is_light(ggplot2::theme_bw))
  expect_true(ggcorrplot:::.panel_is_light(ggplot2::theme_gray))
  expect_false(ggcorrplot:::.panel_is_light(ggplot2::theme_dark))
  # a theme object, not just a theme function
  expect_false(ggcorrplot:::.panel_is_light(ggplot2::theme_dark()))
  # anything that is not a theme is read from the active default instead, which
  # here is the stock light one -- see the dedicated test below
  expect_true(ggcorrplot:::.panel_is_light(NULL))
  expect_true(ggcorrplot:::.panel_is_light("not a theme"))
})

test_that("a dark theme keeps the ramp as given, so its numbers stay readable", {
  contrast <- function(a, b) {
    la <- relative_luminance(a)
    lb <- relative_luminance(b)
    (max(la, lb) + 0.05) / (min(la, lb) + 0.05)
  }
  set.seed(42)
  x <- matrix(stats::rnorm(300 * 6), 300, 6,
              dimnames = list(NULL, paste0("item", seq_len(6))))
  weak <- round(stats::cor(x), 2)
  drawn <- function(th) {
    p <- ggcorrplot(weak, lower.method = "number", upper.method = "number", ggtheme = th)
    unique(ggplot2::ggplot_build(p)$data[[1]]$colour)
  }
  # theme_dark's panel is grey50: the undarkened pale middle reads against it
  dark_cols <- drawn(ggplot2::theme_dark)
  expect_true(all(vapply(dark_cols, contrast, numeric(1), "grey50") >= 3.5))
  # and the default light panel still gets the darkened ramp
  expect_false(identical(sort(dark_cols), sort(drawn(ggplot2::theme_minimal))))
})

test_that("a dark background set via plot.background is detected too", {
  # theme_minimal (our default) and theme_void blank panel.background, so a dark
  # recipe built on either carries its color on plot.background. Reading only
  # panel.background classified those as light and darkened the text onto a dark
  # panel -- the exact failure the light/dark gate exists to prevent.
  dark_plot_bg <- ggplot2::theme_minimal() +
    ggplot2::theme(plot.background = ggplot2::element_rect(fill = "grey10", colour = NA))
  expect_false(ggcorrplot:::.panel_is_light(dark_plot_bg))
  expect_false(ggcorrplot:::.panel_is_light(
    ggplot2::theme_void() + ggplot2::theme(plot.background = ggplot2::element_rect(fill = "black"))
  ))
  # a fill inherited from `rect` must resolve as well
  expect_false(ggcorrplot:::.panel_is_light(
    ggplot2::`%+replace%`(
      ggplot2::theme_gray(),
      ggplot2::theme(
        rect = ggplot2::element_rect(fill = "grey10"),
        panel.background = ggplot2::element_rect()
      )
    )
  ))
  # panel.background still wins when it paints one
  expect_true(ggcorrplot:::.panel_is_light(
    ggplot2::theme_gray() + ggplot2::theme(plot.background = ggplot2::element_rect(fill = "black"))
  ))
})

test_that("a transparent background is not mistaken for a dark one", {
  # theme_void's plot.background is transparent black; read as a color it is the
  # darkest possible background, but nothing is painted -- the device shows through.
  expect_true(ggcorrplot:::.panel_is_light(ggplot2::theme_void))
  expect_true(ggcorrplot:::.panel_is_light(
    ggplot2::theme_minimal() +
      ggplot2::theme(panel.background = ggplot2::element_rect(fill = "#00000000"))
  ))
  # ... but a transparent panel still falls through to an opaque dark plot background
  expect_false(ggcorrplot:::.panel_is_light(
    ggplot2::theme_minimal() + ggplot2::theme(
      panel.background = ggplot2::element_rect(fill = "#00000000"),
      plot.background = ggplot2::element_rect(fill = "grey10")
    )
  ))
})

test_that("the light/dark threshold sits at the near-zero stop break-even", {
  # The crossover is the one for the pale middle of the ramp -- the stop the floor
  # exists to rescue. Against a mid-grey panel some intermediate stop always sits at
  # roughly the panel's own luminance whichever branch is taken, so this pins the
  # boundary, not a legibility promise for mid-grey panels.
  expect_false(ggcorrplot:::.panel_is_light(
    ggplot2::theme_minimal() +
      ggplot2::theme(panel.background = ggplot2::element_rect(fill = "grey67"))
  ))
  expect_true(ggcorrplot:::.panel_is_light(
    ggplot2::theme_minimal() +
      ggplot2::theme(panel.background = ggplot2::element_rect(fill = "grey70"))
  ))
})

test_that("a ggtheme that is not a theme still reads the active default", {
  # NULL and friends are ignored when the plot is assembled, so what gets drawn is
  # the active default on its own. Falling through to the bare page instead would
  # call a globally-set dark theme light and darken the text onto it.
  old <- ggplot2::theme_set(
    ggplot2::theme_grey() +
      ggplot2::theme(panel.background = ggplot2::element_rect(fill = "grey10"))
  )
  on.exit(ggplot2::theme_set(old), add = TRUE)
  expect_false(ggcorrplot:::.panel_is_light(NULL))
  expect_false(ggcorrplot:::.panel_is_light("not a theme"))
  expect_false(ggcorrplot:::.panel_is_light(42))
  # and under a light default the same inputs read light
  ggplot2::theme_set(ggplot2::theme_grey())
  expect_true(ggcorrplot:::.panel_is_light(NULL))
  expect_true(ggcorrplot:::.panel_is_light("not a theme"))
})

test_that("resolving the background never errors, whatever ggtheme holds", {
  for (value in list(NULL, NA, 42, "nonsense", list(), ggplot2::element_blank(),
                     function() stop("boom"), function() 42)) {
    result <- ggcorrplot:::.panel_is_light(value)
    expect_true(is.logical(result) && length(result) == 1L && !is.na(result))
  }
})

test_that("a partial ggtheme is resolved against the active default theme", {
  # ggplot2 draws theme_get() + ggtheme, so a theme that sets only a background
  # carries none of the elements the default supplies. Judging it on its own made a
  # bare dark plot.background look dark while the panel actually drawn was the
  # default's light grey -- and the text was then left pale on a pale panel.
  bare_dark_plot_bg <- ggplot2::theme(
    plot.background = ggplot2::element_rect(fill = "grey15", colour = NA)
  )
  expect_true(ggcorrplot:::.panel_is_light(bare_dark_plot_bg))
  # the same background on a complete theme really is dark
  expect_false(ggcorrplot:::.panel_is_light(ggplot2::theme_minimal() + bare_dark_plot_bg))
})

test_that("a globally set dark theme is taken into account", {
  old <- ggplot2::theme_set(ggplot2::theme_dark())
  on.exit(ggplot2::theme_set(old), add = TRUE)
  # nothing passed: the default theme is what gets drawn
  expect_false(ggcorrplot:::.panel_is_light(ggplot2::theme()))
  # an explicit light theme still wins over the global default
  expect_true(ggcorrplot:::.panel_is_light(ggplot2::theme_minimal))
})

test_that("every stock ggplot2 theme is classified by its own background", {
  light <- c("theme_minimal", "theme_bw", "theme_gray", "theme_light",
             "theme_classic", "theme_void", "theme_linedraw", "theme_test")
  for (name in light) {
    fun <- get(name, envir = asNamespace("ggplot2"))
    expect_true(ggcorrplot:::.panel_is_light(fun), info = name)
    expect_true(ggcorrplot:::.panel_is_light(fun()), info = name)
  }
  expect_false(ggcorrplot:::.panel_is_light(ggplot2::theme_dark))
  expect_false(ggcorrplot:::.panel_is_light(ggplot2::theme_dark()))
})

test_that("a partly transparent background is composited, not discarded", {
  # Discarding every non-opaque fill was too blunt: it was meant for theme_void's
  # fully transparent plot.background, but it also threw away a 90%-opaque
  # near-black panel and called it light, darkening the text onto near-black.
  dark_90 <- ggplot2::theme_grey() + ggplot2::theme(
    panel.background = ggplot2::element_rect(
      fill = grDevices::adjustcolor("grey10", alpha.f = 0.9)
    )
  )
  expect_false(ggcorrplot:::.panel_is_light(dark_90))
  # half-opaque black over the default light panel still comes out dark
  expect_false(ggcorrplot:::.panel_is_light(
    ggplot2::theme_grey() + ggplot2::theme(
      panel.background = ggplot2::element_rect(
        fill = grDevices::adjustcolor("black", alpha.f = 0.5)
      )
    )
  ))
  # ... while a fully transparent one paints nothing and the backdrop shows through
  expect_true(ggcorrplot:::.panel_is_light(
    ggplot2::theme_minimal() +
      ggplot2::theme(panel.background = ggplot2::element_rect(fill = "#00000000"))
  ))
})

test_that("compositing follows device, then plot background, then panel", {
  composite <- ggcorrplot:::.composite_over
  # nothing painted -> the backdrop is unchanged
  expect_identical(composite(NULL, "white"), "white")
  expect_identical(composite("#00000000", "white"), "white")
  # opaque -> the fill itself
  expect_identical(composite("black", "white"), "black")
  # half-opaque black over white is mid-grey (0x80 is 128/255, not exactly a half)
  expect_identical(composite("#00000080", "white"), "#7F7F7F")
  # and a transparent panel lets a dark plot background through
  expect_false(ggcorrplot:::.panel_is_light(
    ggplot2::theme_minimal() + ggplot2::theme(
      panel.background = ggplot2::element_rect(fill = "#00000000"),
      plot.background = ggplot2::element_rect(fill = "grey10")
    )
  ))
})

text_labels <- function(g) {
  i <- which(vapply(g$layers, function(L) inherits(L$geom, "GeomText"), logical(1)))
  g$layers[[i]]$aes_params$label
}

test_that("leading.zero defaults to keeping the zero (unchanged behavior)", {
  corr <- round(cor(mtcars), 2)
  labs <- text_labels(ggcorrplot(corr, lab = TRUE))
  # at least one label like 0.xx or -0.xx present, none stripped
  expect_true(any(grepl("^-?0\\.", labs)))
  expect_false(any(grepl("^-?\\.[0-9]", labs)))
})

test_that("leading.zero = FALSE drops the leading zero, including negatives", {
  corr <- round(cor(mtcars), 2)
  labs <- text_labels(ggcorrplot(corr, lab = TRUE, leading.zero = FALSE))
  # no label should keep a leading 0 before the decimal
  expect_false(any(grepl("^-?0\\.", labs)))
  # values in (-1, 1) now start with . or -.
  expect_true(any(grepl("^\\.[0-9]", labs)))   # e.g. .68
  expect_true(any(grepl("^-\\.[0-9]", labs)))  # e.g. -.85
})

test_that("leading.zero = FALSE leaves 1.00 and integers untouched", {
  m <- matrix(c(1, -0.67, 0.23, 1), 2, 2,
    dimnames = list(c("x", "y"), c("x", "y")))
  labs <- text_labels(ggcorrplot(m, lab = TRUE, nsmall = 2, leading.zero = FALSE))
  expect_true("1.00" %in% labs)          # the 0 in 1.00 is not a leading zero
  expect_true("-.67" %in% labs)
  expect_true(".23" %in% labs)
  expect_false(any(labs == "1.0.0"))     # sanity: no double substitution
})

test_that("leading.zero = FALSE composes with sig.stars", {
  corr <- round(cor(mtcars), 2)
  p <- cor_pmat(mtcars)
  labs <- text_labels(
    ggcorrplot(corr, p.mat = p, lab = TRUE, sig.stars = TRUE, leading.zero = FALSE)
  )
  # a starred, zero-stripped label such as -.85*** exists, and none keep 0.
  expect_true(any(grepl("^-?\\.[0-9]+\\*", labs)))
  expect_false(any(grepl("^-?0\\.", labs)))
})

# Cluster rectangles (P0.3): hc.rect = k draws k boxes around the hierarchical
# clusters, on top of the glyph layer. Requires hc.order = TRUE.

corr <- round(cor(mtcars), 1)
n <- ncol(mtcars)

geoms <- function(p) unname(vapply(p$layers, function(l) class(l$geom)[1], character(1)))
rect_data <- function(p) {
  b <- ggplot2::ggplot_build(p)
  i <- which(geoms(p) == "GeomRect")
  b$data[[i]]
}

test_that("hc.rect = NULL (default) adds no rectangle layer", {
  expect_false("GeomRect" %in% geoms(ggcorrplot(corr, hc.order = TRUE)))
  expect_false("GeomRect" %in% geoms(ggcorrplot(corr)))
})

test_that("hc.rect = k draws exactly k rectangles on top of the tiles", {
  p <- ggcorrplot(corr, hc.order = TRUE, hc.rect = 3)
  expect_equal(geoms(p), c("GeomTile", "GeomRect"))
  expect_equal(nrow(rect_data(p)), 3)
})

test_that("the rectangles are square diagonal blocks at half-integer bounds", {
  rd <- rect_data(ggcorrplot(corr, hc.order = TRUE, hc.rect = 4))
  # square: x-span equals y-span for every block
  expect_equal(rd$xmin, rd$ymin)
  expect_equal(rd$xmax, rd$ymax)
  # half-integer cell boundaries within the n x n grid
  expect_true(all((rd$xmin %% 1) == 0.5))
  expect_true(all((rd$xmax %% 1) == 0.5))
  expect_gte(min(rd$xmin), 0.5)
  expect_lte(max(rd$xmax), n + 0.5)
})

test_that("the k blocks are contiguous and partition all n variables", {
  # this is the correctness property: cutree clusters are contiguous in
  # dendrogram order, so the blocks tile 1..n with no gap or overlap
  for (k in c(1, 2, 3, 5, n)) {
    rd <- rect_data(ggcorrplot(corr, hc.order = TRUE, hc.rect = k))
    lo <- sort(rd$xmin + 0.5)
    hi <- sort(rd$xmax - 0.5)
    expect_equal(nrow(rd), k)
    expect_equal(min(lo), 1) # first block starts at position 1
    expect_equal(max(hi), n) # last block ends at position n
    # each block's end is the next block's start - 1 (no gap, no overlap)
    expect_equal(hi[-k], lo[-1] - 1)
  }
})

test_that("hc.rect requires hc.order = TRUE", {
  expect_error(ggcorrplot(corr, hc.rect = 3), "hc.order")
})

test_that("hc.rect requires type = 'full' (no boxes over a blanked triangle)", {
  expect_error(ggcorrplot(corr, hc.order = TRUE, type = "lower", hc.rect = 3), "full")
  expect_error(ggcorrplot(corr, hc.order = TRUE, type = "upper", hc.rect = 3), "full")
})

test_that("hc.rect draws correctly for numeric-looking dimnames and as.is (#37 fixed)", {
  # the axis is coerced to a factor in cluster order regardless of how melt()
  # renders the names, so the boxes land on the right cells even here
  mn <- corr
  dimnames(mn) <- list(as.character(seq_len(n)), as.character(seq_len(n)))
  p <- ggcorrplot(mn, hc.order = TRUE, hc.rect = 3)
  # the axis follows the clustering, not the numeric value order
  expect_identical(
    levels(p$data$Var1),
    as.character(seq_len(n))[hclust(as.dist((1 - mn) / 2))$order]
  )
  # exactly 3 square diagonal blocks, contiguously partitioning the variables
  rd <- rect_data(p)
  expect_equal(nrow(rd), 3)
  expect_equal(rd$xmin, rd$ymin)
  expect_equal(min(rd$xmin), 0.5)
  expect_equal(max(rd$xmax), n + 0.5)
  # as.is = TRUE also works
  expect_s3_class(ggplot2::ggplotGrob(ggcorrplot(corr, hc.order = TRUE, hc.rect = 3, as.is = TRUE)), "gtable")
})

test_that("hc.rect validates k", {
  expect_error(ggcorrplot(corr, hc.order = TRUE, hc.rect = 0), "between 1")
  expect_error(ggcorrplot(corr, hc.order = TRUE, hc.rect = n + 1), "between 1")
  expect_error(ggcorrplot(corr, hc.order = TRUE, hc.rect = 2.5), "integer")
  expect_error(ggcorrplot(corr, hc.order = TRUE, hc.rect = c(2, 3)), "single")
})

test_that("hc.rect composes with a mixed layout and renders", {
  expect_s3_class(
    ggplot2::ggplotGrob(ggcorrplot(corr,
      hc.order = TRUE, hc.rect = 3,
      lower.method = "number", upper.method = "circle"
    )),
    "gtable"
  )
})

test_that("adding hc.rect does not break partial matching of hc.order/hc.method", {
  # hc.rect shares the already-ambiguous 'hc' prefix; the unique 'hc.o'/'hc.m'
  # abbreviations must still resolve
  expect_true("GeomRect" %in% geoms(ggcorrplot(corr, hc.o = TRUE, hc.rect = 2)))
  expect_silent(ggcorrplot(corr, hc.order = TRUE, hc.m = "average"))
})

# Regression tests for p-value matrix handling (#25, #37)

# Count the significance-marker (pch = 4 cross) glyphs in a built plot.
.n_crosses <- function(p) {
  b <- ggplot2::ggplot_build(p)$data
  cl <- Filter(function(d) "shape" %in% names(d) && nrow(d) > 0 && all(d$shape == 4), b)
  if (length(cl)) nrow(cl[[1]]) else 0L
}

test_that("hc.order does not alter significance via p-value rounding (#25)", {
  cmat <- matrix(c(1, 0.3, 0.2, 0.3, 1, 0.25, 0.2, 0.25, 1), 3,
                 dimnames = list(letters[1:3], letters[1:3]))
  # p = 0.054 is just ABOVE the default sig.level (0.05); it must stay
  # non-significant (a cross is drawn) whether or not hc.order is used.
  pmat <- matrix(c(0, 0.054, 0.20, 0.054, 0, 0.30, 0.20, 0.30, 0), 3,
                 dimnames = list(letters[1:3], letters[1:3]))
  n_no_hc <- .n_crosses(ggcorrplot(cmat, p.mat = pmat, insig = "pch"))
  n_hc    <- .n_crosses(ggcorrplot(cmat, p.mat = pmat, hc.order = TRUE, insig = "pch"))
  # all 6 off-diagonal cells are non-significant -> 6 crosses either way
  expect_equal(n_no_hc, 6L)
  expect_equal(n_hc, n_no_hc)
})

test_that("hc.order leaves significance unchanged for non-boundary p (#25 no-regression)", {
  corr <- round(cor(mtcars), 1)
  p    <- cor_pmat(mtcars)
  expect_equal(
    .n_crosses(ggcorrplot(corr, p.mat = p, hc.order = TRUE,  insig = "pch")),
    .n_crosses(ggcorrplot(corr, p.mat = p, hc.order = FALSE, insig = "pch"))
  )
})

test_that("p-values stay aligned when corr and p.mat NA patterns differ", {
  c4 <- round(cor(mtcars[, 1:4]), 2)
  p4 <- cor_pmat(mtcars[, 1:4])
  # remove one pair from the p-value matrix only -> different NA pattern
  p4["mpg", "disp"] <- p4["disp", "mpg"] <- NA
  # previously this raised "replacement has 14 rows, data has 16"
  expect_no_error(ggcorrplot(c4, p.mat = p4, insig = "pch"))
  # blank mode must not error either (unknown-significance cells are kept)
  expect_no_error(ggcorrplot(c4, p.mat = p4, insig = "blank"))
  expect_no_error(ggcorrplot(c4, p.mat = p4, insig = "blank", lab = TRUE))
})

test_that("significance markers are matched to cells by name, not position", {
  m <- matrix(c(1, 0.9, 0.2, 0.9, 1, 0.1, 0.2, 0.1, 1), 3,
              dimnames = list(c("a", "b", "c"), c("a", "b", "c")))
  # only the a~c pair is non-significant
  p <- matrix(c(0, 0.001, 0.6, 0.001, 0, 0.002, 0.6, 0.002, 0), 3,
              dimnames = list(c("a", "b", "c"), c("a", "b", "c")))
  cross <- .n_crosses(ggcorrplot(m, p.mat = p, insig = "pch"))
  expect_equal(cross, 2L)   # exactly a~c and c~a
})

test_that("p.mat aligns with numeric-looking names when as.is = TRUE (#37)", {
  nm <- c("10", "2", "33")
  m  <- matrix(c(1, 0.8, 0.2, 0.8, 1, 0.1, 0.2, 0.1, 1), 3, dimnames = list(nm, nm))
  pm <- matrix(c(0, 0.6, 0.9, 0.6, 0, 0.7, 0.9, 0.7, 0), 3, dimnames = list(nm, nm))
  b  <- ggplot2::ggplot_build(ggcorrplot(m, p.mat = pm, as.is = TRUE, insig = "pch"))$data
  cl <- Filter(function(d) "shape" %in% names(d) && nrow(d) > 0 && all(d$shape == 4), b)
  expect_true(length(cl) > 0)
  # crosses must land on the discrete tile positions (1..3), not the literal
  # names (10, 33) that would otherwise place them off-plot.
  expect_true(all(cl[[1]]$x %in% seq_len(3)))
  expect_true(all(cl[[1]]$y %in% seq_len(3)))
})

# palette = : named colorblind-safe diverging palettes as a convenience shortcut
# for colors. Default NULL leaves colors (and every existing call) unchanged.

corr <- round(cor(mtcars), 1)
fill <- function(p) ggplot2::ggplot_build(p)$data[[1]]

test_that(".ggcorrplot_palette returns the pinned colorblind-safe hex (visual contract)", {
  rdbu <- .ggcorrplot_palette("RdBu")
  puor <- .ggcorrplot_palette("PuOr")
  expect_length(rdbu, 11)
  expect_length(puor, 11)
  # low = cool, center = white, high = warm (matches the default blue/white/red polarity)
  expect_identical(rdbu[c(1, 6, 11)], c("#053061", "#F7F7F7", "#67001F"))
  expect_identical(puor[c(1, 6, 11)], c("#2D004B", "#F7F7F7", "#7F3B08"))
})

test_that("palette = 'RdBu' is exactly equivalent to passing its hex vector to colors", {
  expect_equal(
    fill(ggcorrplot(corr, palette = "RdBu")),
    fill(ggcorrplot(corr, colors = .ggcorrplot_palette("RdBu")))
  )
})

test_that("palette = NULL (the default) leaves the fill unchanged, and RdBu differs from it", {
  expect_equal(fill(ggcorrplot(corr)), fill(ggcorrplot(corr, palette = NULL)))
  # the RdBu ramp is genuinely different from the default blue/white/red
  expect_false(isTRUE(all.equal(
    fill(ggcorrplot(corr))$fill,
    fill(ggcorrplot(corr, palette = "RdBu"))$fill
  )))
})

test_that("palette takes precedence over colors when both are supplied", {
  expect_equal(
    fill(ggcorrplot(corr, palette = "RdBu", colors = c("blue", "white", "red"))),
    fill(ggcorrplot(corr, palette = "RdBu"))
  )
})

test_that("an unknown palette errors", {
  expect_error(ggcorrplot(corr, palette = "viridis"))
  expect_error(ggcorrplot(corr, palette = "rdbu")) # match.arg is case-sensitive
})

test_that("palette also colors a mixed 'number' triangle (same colors source)", {
  # the mixed number colour scale reads the same resolved colors
  p <- ggcorrplot(corr, lower.method = "number", upper.method = "circle", palette = "RdBu")
  expect_silent(ggplot2::ggplot_build(p))
})

# preset = "publication": a one-token bundle of publication-grade defaults (white
# cell outlines + the colorblind-safe RdBu palette). It fills only the arguments
# the caller did NOT supply, so explicit arguments always win, and preset = NULL
# (the default) changes nothing.

corr <- round(cor(mtcars), 1)
fill <- function(p) ggplot2::ggplot_build(p)$data[[1]]$fill
outline <- function(p) {
  i <- which(vapply(p$layers, function(l) class(l$geom)[1], "") %in% c("GeomTile", "GeomPoint"))[1]
  p$layers[[i]]$aes_params$colour
}

test_that("preset = 'publication' sets white outlines and the RdBu palette in one token", {
  p <- ggcorrplot(corr, preset = "publication")
  expect_identical(outline(p), "white")
  expect_equal(fill(p), fill(ggcorrplot(corr, palette = "RdBu", outline.color = "white")))
})

test_that("preset = NULL (the default) leaves every existing call unchanged", {
  expect_equal(
    ggplot2::ggplot_build(ggcorrplot(corr))$data,
    ggplot2::ggplot_build(ggcorrplot(corr, preset = NULL))$data
  )
  # the default outline is still gray, not white
  expect_identical(outline(ggcorrplot(corr)), "gray")
})

test_that("an explicit outline.color overrides the preset", {
  expect_identical(outline(ggcorrplot(corr, preset = "publication", outline.color = "black")), "black")
})

test_that("an explicit colors overrides the preset palette (colors is not clobbered)", {
  # user pins colors -> preset must NOT swap in RdBu
  expect_equal(
    fill(ggcorrplot(corr, preset = "publication", colors = c("blue", "white", "red"))),
    fill(ggcorrplot(corr))
  )
})

test_that("an explicit palette overrides the preset palette", {
  expect_equal(
    fill(ggcorrplot(corr, preset = "publication", palette = "PuOr")),
    fill(ggcorrplot(corr, palette = "PuOr"))
  )
})

test_that("an unknown preset errors", {
  expect_error(ggcorrplot(corr, preset = "fancy"))
  expect_error(ggcorrplot(corr, preset = "Publication")) # match.arg is case-sensitive
})

# hc.rect.col: control the outline color of the hc.rect cluster rectangles.
# Default "gray30" keeps existing output byte-identical.

corr <- round(cor(mtcars), 1)
rect_col <- function(p) {
  i <- which(vapply(p$layers, function(l) class(l$geom)[1], "") == "GeomRect")
  p$layers[[i]]$aes_params$colour
}

test_that("hc.rect.col defaults to gray30 (unchanged output)", {
  p <- ggcorrplot(corr, hc.order = TRUE, hc.rect = 3)
  expect_identical(rect_col(p), "gray30")
  # explicit default equals the implicit default (byte-identical layer data)
  expect_equal(
    ggplot2::ggplot_build(ggcorrplot(corr, hc.order = TRUE, hc.rect = 3))$data,
    ggplot2::ggplot_build(ggcorrplot(corr, hc.order = TRUE, hc.rect = 3, hc.rect.col = "gray30"))$data
  )
})

test_that("hc.rect.col sets the rectangle outline color", {
  expect_identical(rect_col(ggcorrplot(corr, hc.order = TRUE, hc.rect = 3, hc.rect.col = "white")), "white")
  expect_identical(rect_col(ggcorrplot(corr, hc.order = TRUE, hc.rect = 3, hc.rect.col = "black")), "black")
  expect_identical(rect_col(ggcorrplot(corr, hc.order = TRUE, hc.rect = 2, hc.rect.col = "#E46726")), "#E46726")
})

test_that("hc.rect.col is inert when no rectangles are drawn", {
  # no hc.rect -> no GeomRect layer, and setting hc.rect.col changes nothing
  p <- ggcorrplot(corr, hc.order = TRUE, hc.rect.col = "white")
  expect_false("GeomRect" %in% vapply(p$layers, function(l) class(l$geom)[1], ""))
  expect_equal(
    ggplot2::ggplot_build(ggcorrplot(corr, hc.order = TRUE))$data,
    ggplot2::ggplot_build(ggcorrplot(corr, hc.order = TRUE, hc.rect.col = "white"))$data
  )
})

if (getRversion() >= "4.1") {
  test_that("plots are rendered correctly", {
    skip_on_cran()
    # vdiffr snapshots are SVG-engine/ggplot2-version specific and are not
    # portable across CI runners; validate them locally, not on CI.
    skip_on_ci()
    skip_if_not_installed("vdiffr")

    # compute needed details
    set.seed(123)
    corr <- round(cor(mtcars), 1)
    p.mat <- cor_pmat(mtcars)

    set.seed(123)
    vdiffr::expect_doppelganger(
      title = "ggcorrplot works - default",
      fig = ggcorrplot(corr)
    )

    set.seed(123)
    vdiffr::expect_doppelganger(
      title = "ggcorrplot works - circle",
      fig = ggcorrplot(corr, method = "circle")
    )

    set.seed(123)
    vdiffr::expect_doppelganger(
      title = "ggcorrplot works - hc",
      fig = ggcorrplot(corr, hc.order = TRUE, outline.color = "white")
    )

    set.seed(123)
    vdiffr::expect_doppelganger(
      title = "ggcorrplot works - mixed",
      fig = ggcorrplot(corr,
        lower.method = "number", upper.method = "circle",
        show.legend = FALSE
      )
    )

    set.seed(123)
    vdiffr::expect_doppelganger(
      title = "ggcorrplot works - hc.rect",
      fig = ggcorrplot(corr, hc.order = TRUE, hc.rect = 3, outline.color = "white")
    )

    set.seed(123)
    vdiffr::expect_doppelganger(
      title = "ggcorrplot works - insig stars",
      fig = ggcorrplot(corr, p.mat = p.mat, insig = "stars")
    )

    set.seed(123)
    # non-square matrix with show.diag = FALSE: only the genuine self-pairs
    # (disp, hp, wt) are blanked, not the positional diagonal
    nonsq <- round(cor(mtcars), 1)[
      c("disp", "hp", "wt"), c("mpg", "cyl", "disp", "hp", "wt")
    ]
    vdiffr::expect_doppelganger(
      title = "ggcorrplot works - non-square no-diag",
      fig = ggcorrplot(nonsq, show.diag = FALSE, lab = TRUE)
    )

    set.seed(123)
    vdiffr::expect_doppelganger(
      title = "ggcorrplot works - palette RdBu",
      fig = ggcorrplot(corr, palette = "RdBu", outline.color = "white", lab = TRUE)
    )

    set.seed(123)
    vdiffr::expect_doppelganger(
      title = "ggcorrplot works - preset publication",
      fig = ggcorrplot(corr, preset = "publication", lab = TRUE)
    )

    set.seed(123)
    vdiffr::expect_doppelganger(
      title = "ggcorrplot works - scale square",
      fig = ggcorrplot(corr, scale.square = TRUE, outline.color = "white")
    )

    set.seed(123)
    vdiffr::expect_doppelganger(
      title = "ggcorrplot works - cell grid circle",
      fig = ggcorrplot(corr, method = "circle", cell.grid = TRUE)
    )
  })
}

# Tests for the circle.scale argument (#8)

test_that("circle.scale scales the circle sizes; default is unchanged (#8)", {
  corr <- round(cor(mtcars), 1)
  size_range <- function(cs) {
    b <- ggplot2::ggplot_build(ggcorrplot(corr, method = "circle", circle.scale = cs))$data
    pts <- Filter(function(d) "size" %in% names(d) && nrow(d) > 0 && all(d$shape == 21), b)
    range(pts[[1]]$size)
  }
  # default range is c(4, 10); circle.scale multiplies it uniformly
  expect_equal(size_range(1), c(4, 10))
  expect_equal(size_range(2), c(8, 20))
})

test_that("circle.scale has no effect on method = 'square' (#8)", {
  corr <- round(cor(mtcars), 1)
  b1 <- ggplot2::ggplot_build(ggcorrplot(corr, circle.scale = 1))$data
  b3 <- ggplot2::ggplot_build(ggcorrplot(corr, circle.scale = 3))$data
  expect_identical(b1, b3)
})

# cell.grid: draw a light rectangle behind every (sized) cell -- the corrplot
# boxed-cell look. Default FALSE keeps every existing call byte-identical.

corr <- round(cor(mtcars), 1)
geoms <- function(p) unname(vapply(p$layers, function(l) class(l$geom)[1], ""))
first_layer_col <- function(p) p$layers[[1]]$aes_params$colour

test_that("cell.grid defaults to FALSE: no cell-grid layer, output unchanged", {
  # circle default has exactly one glyph layer (GeomPoint), no background tile
  p <- ggcorrplot(corr, method = "circle")
  expect_identical(geoms(p), "GeomPoint")
  # explicit FALSE == implicit default (byte-identical built data)
  expect_equal(
    ggplot2::ggplot_build(ggcorrplot(corr, method = "circle"))$data,
    ggplot2::ggplot_build(ggcorrplot(corr, method = "circle", cell.grid = FALSE))$data
  )
})

test_that("cell.grid = TRUE boxes circles: a GeomTile is drawn BEFORE the glyph", {
  p <- ggcorrplot(corr, method = "circle", cell.grid = TRUE)
  g <- geoms(p)
  # background tile first, glyph second
  expect_identical(g[1], "GeomTile")
  expect_identical(g[2], "GeomPoint")
  # the background tile has no fill and uses the default cell.grid.col
  expect_true(is.na(p$layers[[1]]$aes_params$fill))
  expect_identical(first_layer_col(p), "grey90")
})

test_that("cell.grid = TRUE boxes size-scaled squares", {
  p <- ggcorrplot(corr, scale.square = TRUE, cell.grid = TRUE)
  g <- geoms(p)
  expect_identical(g[1], "GeomTile")
  expect_identical(g[2], "GeomPoint")
  expect_identical(p$layers[[2]]$aes_params$shape, 22)
})

test_that("cell.grid.col sets the cell border color", {
  p <- ggcorrplot(corr, method = "circle", cell.grid = TRUE, cell.grid.col = "black")
  expect_identical(first_layer_col(p), "black")
})

test_that("cell.grid has no effect on a full-tile square heatmap", {
  # method = "square" without scale.square already draws a bordered tile, so no
  # extra background tile is added and the built data is unchanged
  a <- ggcorrplot(corr, method = "square")
  b <- ggcorrplot(corr, method = "square", cell.grid = TRUE)
  expect_identical(geoms(a), "GeomTile")
  expect_identical(geoms(b), "GeomTile") # still a single tile layer
  expect_equal(
    ggplot2::ggplot_build(a)$data,
    ggplot2::ggplot_build(b)$data
  )
  # "no effect" must include the theme: the gridlines are NOT blanked for a
  # full-tile square heatmap (no box was drawn to replace them). Checked on a
  # lower triangle, where those gridlines are actually visible in the blank half.
  low <- ggcorrplot(corr, method = "square", type = "lower", cell.grid = TRUE)
  expect_false(inherits(b$theme$panel.grid.major, "element_blank"))
  expect_false(inherits(low$theme$panel.grid.major, "element_blank"))
})

test_that("cell.grid = TRUE blanks the panel gridlines", {
  off <- ggcorrplot(corr, method = "circle")
  on <- ggcorrplot(corr, method = "circle", cell.grid = TRUE)
  # default keeps the theme's gridlines; cell.grid removes them
  expect_false(inherits(off$theme$panel.grid.major, "element_blank"))
  expect_true(inherits(on$theme$panel.grid.major, "element_blank"))
  expect_true(inherits(on$theme$panel.grid.minor, "element_blank"))
})

test_that("cell.grid boxes every region of a mixed layout except full-tile squares", {
  # circle, number and diagonal-name regions each get a background box tile
  p <- ggcorrplot(corr,
    lower.method = "number", upper.method = "circle", cell.grid = TRUE,
    show.legend = FALSE
  )
  g <- geoms(p)
  tile_idx <- which(g == "GeomTile")
  # one box per non-empty region (lower number, upper circle, diagonal name)
  expect_identical(length(tile_idx), 3L)
  # every box carries the cell.grid color and maps no fill (transparent box)
  cols <- vapply(tile_idx, function(i) p$layers[[i]]$aes_params$colour, "")
  expect_true(all(cols == "grey90"))
  has_fill_map <- vapply(tile_idx, function(i) "fill" %in% names(p$layers[[i]]$mapping), TRUE)
  expect_false(any(has_fill_map))
})

test_that("a full-tile square region in a mixed layout is not double-boxed", {
  # lower = square (full tile, has its own outline.color border) -> no extra
  # cell.grid tile for that region; upper = circle -> boxed
  p <- ggcorrplot(corr,
    lower.method = "square", upper.method = "circle", cell.grid = TRUE,
    show.legend = FALSE
  )
  g <- geoms(p)
  # GeomTile layers = the full-tile square region (1) + the circle region's box
  # (1) + the diagonal name box (1) = fewer than if every region were boxed.
  # Assert the full-tile square region's tile is the bordered heatmap tile, not a
  # transparent cell.grid box: it maps fill and uses outline.color.
  square_tiles <- Filter(function(l) {
    class(l$geom)[1] == "GeomTile" && "fill" %in% names(l$mapping)
  }, p$layers)
  expect_true(length(square_tiles) >= 1)
})

fill_scale <- function(g) g$scales$get_scales("fill")

n_fill_scales <- function(g) {
  sum(vapply(g$scales$scales, function(s) "fill" %in% s$aesthetics, logical(1)))
}

test_that("the default (length-3) colors still use scale_fill_gradient2", {
  corr <- round(cor(mtcars), 1)
  g <- ggcorrplot(corr)
  expect_equal(n_fill_scales(g), 1L)
  cl <- fill_scale(g)$call
  if (!is.null(cl)) {
    expect_match(paste(deparse(cl), collapse = " "), "gradient2")
  }
})

test_that("an explicit length-3 colors vector keeps the gradient2 path", {
  corr <- round(cor(mtcars), 1)
  g <- ggcorrplot(corr, colors = c("#6D9EC1", "white", "#E46726"))
  cl <- fill_scale(g)$call
  if (!is.null(cl)) {
    expect_match(paste(deparse(cl), collapse = " "), "gradient2")
  }
})

test_that("a colors vector of length != 3 uses gradientn and one fill scale", {
  corr <- round(cor(mtcars), 1)
  pal <- c("#67001F", "#D6604D", "#F7F7F7", "#4393C3", "#053061") # length 5
  g <- ggcorrplot(corr, colors = pal)
  # exactly one fill scale: the palette is applied without adding a second one
  expect_equal(n_fill_scales(g), 1L)
  cl <- fill_scale(g)$call
  if (!is.null(cl)) {
    expect_match(paste(deparse(cl), collapse = " "), "gradientn")
  }
  # builds without error (a longer palette used to require a manual second scale)
  expect_silent(ggplot2::ggplot_build(g))
})

test_that("a length-2 colors vector also works via gradientn", {
  corr <- round(cor(mtcars), 1)
  g <- ggcorrplot(corr, colors = c("navy", "gold"))
  expect_equal(n_fill_scales(g), 1L)
  cl <- fill_scale(g)$call
  if (!is.null(cl)) {
    expect_match(paste(deparse(cl), collapse = " "), "gradientn")
  }
})

test_that("fewer than 2 colors gives a clear error", {
  corr <- round(cor(mtcars), 1)
  expect_error(ggcorrplot(corr, colors = "red"), "at least 2")
})

test_that("legend.limit is honored on the gradientn path", {
  corr <- round(cor(mtcars), 1)
  pal <- c("#67001F", "#D6604D", "#F7F7F7", "#4393C3", "#053061")
  g <- ggcorrplot(corr, colors = pal, legend.limit = c(-1, 1))
  expect_equal(fill_scale(g)$limits, c(-1, 1))
})

# Contract of the internal builders extracted from ggcorrplot() (P0.0).
# These helpers are unexported, but the mixed-method and ellipse paths are built
# on them, so their return shape is a real contract worth pinning. The behavior
# they produce is covered byte-for-byte by test-structure.R (the plot is
# unchanged by the extraction); here we lock the shape of what they return.

corr <- round(cor(mtcars), 1)
p.mat <- cor_pmat(mtcars)
n <- ncol(mtcars)

test_that(".build_corr_df returns the melted corr frame and a NULL p.mat when none is given", {
  b <- .build_corr_df(
    corr = corr, p.mat = NULL, type = "full", show.diag = TRUE,
    hc.order = FALSE, hc.method = "complete", digits = 2,
    sig.level = 0.05, insig = "pch", as.is = FALSE
  )
  expect_named(b, c("corr", "p.mat", "hc"))
  expect_s3_class(b$corr, "data.frame")
  expect_null(b$p.mat)
  expect_null(b$hc) # no clustering requested
  expect_true(all(c("Var1", "Var2", "value", "pvalue", "signif", "abs_corr") %in% names(b$corr)))
  expect_equal(nrow(b$corr), n * n)
  # with no p.mat, significance columns are all NA
  expect_true(all(is.na(b$corr$pvalue)))
})

test_that(".build_corr_df returns the hclust object when hc.order = TRUE", {
  b <- .build_corr_df(
    corr = corr, p.mat = NULL, type = "full", show.diag = TRUE,
    hc.order = TRUE, hc.method = "complete", digits = 2,
    sig.level = 0.05, insig = "pch", as.is = FALSE
  )
  expect_s3_class(b$hc, "hclust")
  # its $order reproduces the reordering applied to the melted data
  expect_identical(levels(b$corr$Var1), colnames(corr)[b$hc$order])
})

test_that(".build_corr_df joins p-values and returns the insignificant-cells frame", {
  b <- .build_corr_df(
    corr = corr, p.mat = p.mat, type = "full", show.diag = TRUE,
    hc.order = FALSE, hc.method = "complete", digits = 2,
    sig.level = 0.05, insig = "pch", as.is = FALSE
  )
  expect_s3_class(b$p.mat, "data.frame")
  # the p.mat frame holds exactly the cells with p > sig.level
  expect_equal(nrow(b$p.mat), sum(p.mat > 0.05))
  # every corr cell's pvalue is its own (Var1, Var2) pair's p-value
  expected <- p.mat[cbind(as.character(b$corr$Var1), as.character(b$corr$Var2))]
  expect_equal(b$corr$pvalue, unname(expected))
})

test_that(".build_corr_df applies the triangle mask via row count", {
  tri <- n * (n - 1) / 2
  lower <- .build_corr_df(
    corr = corr, p.mat = NULL, type = "lower", show.diag = FALSE,
    hc.order = FALSE, hc.method = "complete", digits = 2,
    sig.level = 0.05, insig = "pch", as.is = FALSE
  )
  expect_equal(nrow(lower$corr), tri)
})

test_that(".build_corr_df errors on a non-square matrix with hc.order or a triangle", {
  ns <- cor(mtcars)[1:3, 1:5]
  expect_error(
    .build_corr_df(ns, NULL, "full", TRUE, TRUE, "complete", 2, 0.05, "pch", FALSE),
    "square"
  )
  expect_error(
    .build_corr_df(ns, NULL, "lower", FALSE, FALSE, "complete", 2, 0.05, "pch", FALSE),
    "square"
  )
})

test_that(".method_layer returns a single tile layer for square", {
  layers <- .method_layer("square", outline.color = "gray", circle.scale = 1)
  expect_type(layers, "list")
  expect_length(layers, 1)
  expect_s3_class(layers[[1]], "LayerInstance")
  expect_s3_class(layers[[1]]$geom, "GeomTile")
})

test_that(".method_layer returns a point layer plus size scale and guide for circle", {
  layers <- .method_layer("circle", outline.color = "gray", circle.scale = 1)
  expect_length(layers, 3)
  expect_s3_class(layers[[1]], "LayerInstance")
  expect_s3_class(layers[[1]]$geom, "GeomPoint")
  expect_s3_class(layers[[2]], "Scale")
  # the layers add cleanly onto a ggplot (the caller does p + .method_layer(...))
  d <- .build_corr_df(corr, NULL, "full", TRUE, FALSE, "complete", 2, 0.05, "pch", FALSE)$corr
  p <- ggplot2::ggplot(d, ggplot2::aes(Var1, Var2, fill = value)) + layers
  expect_s3_class(ggplot2::ggplotGrob(p), "gtable")
})

test_that("coord.fixed toggles the coordinate system", {
  corr <- round(cor(mtcars), 1)
  # default: fixed aspect ratio (ratio == 1)
  expect_equal(ggcorrplot(corr)$coordinates$ratio, 1)
  # opt-out: cartesian coord, no fixed ratio
  expect_null(ggcorrplot(corr, coord.fixed = FALSE)$coordinates$ratio)
})

test_that("coord.fixed default output matches an unconditional coord_fixed()", {
  corr <- round(cor(mtcars), 1)
  d <- ggcorrplot(corr)$coordinates
  expect_identical(class(d), class(ggplot2::coord_fixed()))
  expect_identical(d$ratio, ggplot2::coord_fixed()$ratio)
})

test_that("lab_fontface is applied to the coefficient labels", {
  corr <- round(cor(mtcars), 1)
  g <- ggcorrplot(corr, lab = TRUE, lab_fontface = "bold")
  txt <- g$layers[[which(vapply(
    g$layers, function(L) inherits(L$geom, "GeomText"), logical(1)
  ))]]
  expect_identical(txt$aes_params$fontface, "bold")
  # default stays "plain"
  g0 <- ggcorrplot(corr, lab = TRUE)
  txt0 <- g0$layers[[which(vapply(
    g0$layers, function(L) inherits(L$geom, "GeomText"), logical(1)
  ))]]
  expect_identical(txt0$aes_params$fontface, "plain")
})

test_that("tl.vjust / tl.hjust set the x-axis text justification", {
  corr <- round(cor(mtcars), 1)
  th <- ggplot2::calc_element(
    "axis.text.x", ggcorrplot(corr, tl.vjust = 0.5, tl.hjust = 0)$theme
  )
  expect_equal(th$vjust, 0.5)
  expect_equal(th$hjust, 0)
  # defaults are 1 / 1
  th0 <- ggplot2::calc_element("axis.text.x", ggcorrplot(corr)$theme)
  expect_equal(th0$vjust, 1)
  expect_equal(th0$hjust, 1)
})

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ggcorrplot.R
\name{ggcorrplot}
\alias{ggcorrplot}
\alias{cor_pmat}
\title{Visualization of a correlation matrix using ggplot2}
\usage{
ggcorrplot(
  corr,
  method = c("square", "circle"),
  type = c("full", "lower", "upper"),
  ggtheme = ggplot2::theme_minimal,
  title = "",
  show.legend = TRUE,
  legend.title = "Corr",
  show.diag = NULL,
  colors = c("blue", "white", "red"),
  outline.color = "gray",
  hc.order = FALSE,
  hc.method = "complete",
  lab = FALSE,
  lab_col = "black",
  lab_size = 4,
  lab_fontface = "plain",
  sig.stars = FALSE,
  p.mat = NULL,
  sig.level = 0.05,
  insig = c("pch", "blank", "stars"),
  pch = 4,
  pch.col = "black",
  pch.cex = 5,
  tl.cex = 12,
  tl.col = NULL,
  tl.srt = 45,
  tl.vjust = 1,
  tl.hjust = 1,
  digits = 2,
  as.is = FALSE,
  nsmall = 0L,
  leading.zero = TRUE,
  legend.limit = c(-1, 1),
  circle.scale = 1,
  coord.fixed = TRUE,
  lower.method = NULL,
  upper.method = NULL,
  hc.rect = NULL,
  palette = NULL,
  preset = NULL,
  hc.rect.col = "gray30",
  scale.square = FALSE,
  cell.grid = FALSE,
  cell.grid.col = "grey90"
)

cor_pmat(x, ..., use = c("pairwise.complete.obs", "everything"))
}
\arguments{
\item{corr}{the correlation matrix to visualize}

\item{method}{character, the visualization method of correlation matrix to be
used. Allowed values are "square" (default), "circle".}

\item{type}{character, "full" (default), "lower" or "upper" display. A mixed
layout (see \code{lower.method}/\code{upper.method}) always uses the full
matrix.}

\item{ggtheme}{ggplot2 function or theme object. Default value is
`theme_minimal`. Allowed values are the official ggplot2 themes including
theme_gray, theme_bw, theme_minimal, theme_classic, theme_void, .... Theme
objects are also allowed (e.g., `theme_classic()`). A mixed "number" region
reads the background from this argument, resolved against the default theme
in force when \code{ggcorrplot()} is called, to decide how dark to draw the
coefficient text (see \code{lower.method}/\code{upper.method}). So a dark
theme belongs here rather than added to the returned plot with \code{+}, and
a \code{\link[ggplot2]{theme_set}} issued after the call is not seen.}

\item{title}{character, title of the graph.}

\item{show.legend}{logical, if TRUE the legend is displayed.}

\item{legend.title}{a character string for the legend title. lower
triangular, upper triangular or full matrix.}

\item{show.diag}{NULL or logical, whether display the correlation
coefficients on the principal diagonal. If \code{NULL}, the default is to
show diagonal correlation for \code{type = "full"} and to remove it when
\code{type} is one of "upper" or "lower".}

\item{colors}{a vector of colors for the fill gradient. The default is a
length-3 vector for the low, mid and high correlation values (mapped with
\code{\link[ggplot2]{scale_fill_gradient2}}). A vector of any other length
(\code{>= 2}) is spread evenly across the scale with
\code{\link[ggplot2]{scale_fill_gradientn}}, so an n-color palette (e.g.
\code{RColorBrewer::brewer.pal(11, "RdBu")}) can be passed directly.}

\item{outline.color}{the outline color of square or circle. Default value is
"gray".}

\item{hc.order}{logical value. If TRUE, correlation matrix will be hc.ordered
using hclust function.}

\item{hc.method}{the agglomeration method to be used in hclust (see ?hclust).}

\item{lab}{logical value. If TRUE, add correlation coefficient on the plot.}

\item{lab_col, lab_size}{size and color to be used for the correlation
coefficient labels. used when lab = TRUE.}

\item{lab_fontface}{the font face (\code{"plain"}, \code{"bold"},
\code{"italic"}, \code{"bold.italic"}) for the correlation coefficient
labels. Default is \code{"plain"}. Used when \code{lab = TRUE}.}

\item{sig.stars}{logical value. If \code{TRUE} and a \code{p.mat} is
supplied, significance stars are appended to the coefficient labels
(\code{***} for p <= 0.001, \code{**} for p <= 0.01, \code{*} for
p <= 0.05), e.g. \code{"-0.85**"}. Only used when \code{lab = TRUE}. Default
is \code{FALSE}. When \code{TRUE}, significance is shown by the stars and
the \code{insig = "pch"} markers are not drawn. These three thresholds are
fixed and are not affected by \code{sig.level}.}

\item{p.mat}{matrix of p-value. If NULL, arguments sig.level, insig, pch,
pch.col, pch.cex is invalid.}

\item{sig.level}{significant level, if the p-value in p-mat is bigger than
sig.level, then the corresponding correlation coefficient is regarded as
insignificant. This governs which cells \code{insig = "pch"} marks and
\code{insig = "blank"} wipes; the star thresholds used by
\code{insig = "stars"} and \code{sig.stars} are fixed (see those arguments)
and do not follow \code{sig.level}.}

\item{insig}{character, how to convey significance from \code{p.mat}: "pch"
(default), "blank" or "stars". "pch" adds a character (see \code{pch}) on the
glyphs of the insignificant cells; "blank" wipes those glyphs away; "stars"
instead marks the SIGNIFICANT cells with significance stars
(\code{***}/\code{**}/\code{*} for p <= 0.001/0.01/0.05 -- fixed thresholds,
not \code{sig.level}). With the default
\code{lab = FALSE} the stars are drawn on their own (in \code{pch.col}, sized
by \code{lab_size}) as a standalone significance map; with \code{lab = TRUE}
they are appended to the coefficient labels (e.g. \code{"-0.85***"}, as with
\code{sig.stars}) so the two do not overprint.}

\item{pch}{add character on the glyphs of insignificant correlation
coefficients (only valid when insig is "pch"). Default value is 4.}

\item{pch.col, pch.cex}{the color and the cex (size) of pch (only valid when
insig is "pch").}

\item{tl.cex, tl.col, tl.srt}{the size, the color and the string rotation of
text label (variable names). \code{tl.col} defaults to \code{NULL}, which
inherits the color from the theme.}

\item{tl.vjust, tl.hjust}{the vertical and horizontal justification of the
x-axis text labels, passed to \code{\link[ggplot2]{element_text}}. Both
default to \code{1}; adjust them to reposition the variable-name labels.}

\item{digits}{Decides the number of decimal digits to be displayed (Default:
`2`).}

\item{as.is}{retained for backward compatibility; no longer affects the plot.
The axis is now always drawn in the matrix (row/column) order, so the
variable-name handling this argument used to control is done internally.}

\item{nsmall}{the minimum number of digits to the right of the decimal point
in the coefficient labels, passed to \code{\link[base]{format}}. Default is
\code{0} (no minimum, current behavior). Set e.g. \code{nsmall = 2} to keep
trailing zeros (such as 0.70). Only used when \code{lab = TRUE}.}

\item{leading.zero}{logical. If \code{TRUE} (default), coefficient labels keep
the leading zero (e.g. \code{0.23}, \code{-0.67}). Set to \code{FALSE} to
drop it (\code{.23}, \code{-.67}), which is common for correlation tables.
Only used when \code{lab = TRUE}.}

\item{legend.limit}{a length-2 numeric vector giving the limits of the fill
color scale. Default \code{c(-1, 1)} (suitable for a correlation matrix); set
to \code{NULL} to use the data range instead, e.g. for a covariance matrix.}

\item{circle.scale}{a scaling factor for the circle sizes when
\code{method = "circle"}. Default is \code{1}; increase it (e.g.
\code{circle.scale = 2}) for larger circles or decrease it for smaller ones,
which is useful when the output device size makes the default circles too
small or too large. Has no effect when \code{method = "square"}.}

\item{coord.fixed}{logical value. If \code{TRUE} (default), the plot uses
\code{\link[ggplot2]{coord_fixed}} so the cells are square. Set to
\code{FALSE} to let the cells fill the plotting area (a non 1:1 aspect
ratio), which can look better with many long variable names.}

\item{lower.method, upper.method}{character, an optional per-triangle glyph for
  a mixed layout: one of "square", "circle" or "number" (the coefficient drawn
  as text, colored by its value on the fill ramp). When either is set, the plot
  switches to a mixed layout where the lower and upper triangles are drawn
  separately and the variable names are drawn on the diagonal; a triangle left
  \code{NULL} uses \code{method}. Both default to \code{NULL} (single-method
  plot, unchanged). In a mixed layout the single-method significance and label
  overlays (\code{lab}, \code{sig.stars}, \code{p.mat}, \code{insig},
  \code{pch*}) do not apply; show coefficients with a "number" triangle instead.

  Over a light background the "number" text is drawn on a darkened copy of the
  ramp -- same hues, so warm still reads as positive and cool as negative, but
  dark enough that a coefficient near zero stays readable instead of washing
  out. Over a dark background the ramp is used as given, its pale middle being
  what reads there. The background is taken from \code{ggtheme}; a theme added
  to the returned plot with \code{+} arrives too late to be seen.}

\item{hc.rect}{integer or \code{NULL} (default). If an integer \code{k}, draws
\code{k} rectangles (no fill) around the clusters obtained by cutting the
hierarchical tree, marking the cluster blocks on the diagonal. Requires
\code{hc.order = TRUE} and \code{type = "full"} (the boxes span whole
diagonal blocks). \code{NULL} (default) draws no rectangles. For a fully
custom box style, add your own \code{annotate("rect", ...)} to the returned
plot.}

\item{palette}{optional name of a built-in colorblind-safe diverging palette
for the fill gradient: \code{"RdBu"} or \code{"PuOr"}. A convenience
shortcut for \code{colors}: when set it supplies the gradient (an 11-stop
ramp, white at zero, cool = negative / warm = positive) and takes precedence
over \code{colors}. Defaults to \code{NULL} (use \code{colors}), so existing
calls are unchanged.}

\item{preset}{optional name of a bundle of publication-grade defaults. The only
value, \code{"publication"}, sets white cell outlines and the colorblind-safe
\code{"RdBu"} palette in one token. It fills only the arguments you did not
supply, so any argument you pass explicitly (e.g. \code{outline.color},
\code{colors}, \code{palette}) overrides the preset. Defaults to \code{NULL}
(no preset), leaving existing calls unchanged.}

\item{hc.rect.col}{the outline color of the \code{hc.rect} cluster rectangles.
Defaults to \code{"gray30"}; set it to any color that suits your palette
(e.g. \code{"black"} for a bolder box, or \code{"white"}). Only used when
\code{hc.rect} is set.}

\item{scale.square}{logical. If \code{TRUE} and \code{method = "square"}, the
squares are sized by the absolute correlation (larger square = stronger
correlation), in addition to the fill color -- the classic corrplot
size-scaled square look. Defaults to \code{FALSE} (constant full-cell
squares, the current behavior). Has no effect for \code{method = "circle"}
(circles are always sized). Uses \code{circle.scale} to tune the size range.
As with \code{method = "circle"}, coefficient labels (\code{lab = TRUE}) are
drawn at full size and may overflow the smallest squares.}

\item{cell.grid}{logical. If \code{TRUE}, draw a light rectangle around every
cell (behind the glyphs) and remove the through-center gridlines, so the
sized glyphs (\code{method = "circle"} or \code{scale.square = TRUE}) sit
inside boxed cells -- the corrplot boxed-cell look. Defaults to \code{FALSE}
(the current behavior). Has no effect on a full-tile square heatmap
(\code{method = "square"} without \code{scale.square}), whose tiles already
carry a cell border (\code{outline.color}).}

\item{cell.grid.col}{the color of the \code{cell.grid} cell borders. Defaults
to \code{"grey90"}. Only used when \code{cell.grid = TRUE}.}

\item{x}{numeric matrix or data frame}

\item{...}{other arguments to be passed to the function cor.test.}

\item{use}{character, how to treat pairs involving missing values when
deciding which cells are \code{NA}. Either \code{"pairwise.complete.obs"}
(default; test every pair that has enough overlapping observations) or
\code{"everything"} (set a pair to \code{NA} as soon as either variable has
a missing value, matching \code{\link[stats]{cor}}'s default). Mirrors the
corresponding values of \code{\link[stats]{cor}}'s \code{use} argument.}
}
\value{
\itemize{ \item ggcorrplot(): Returns a ggplot2 \item cor_pmat():
Returns a matrix containing the p-values of correlations }
}
\description{
\itemize{ \item ggcorrplot(): A graphical display of a
  correlation matrix using ggplot2. The main plot options are walked through in
  \href{https://www.datanovia.com/learn/biostatistics/correlation/ggcorrplot-in-r}{ggcorrplot:
  Correlation Matrix Heatmap in R with ggplot2}. \item cor_pmat(): Compute a
  correlation matrix p-values, to mark the significant cells. A worked
  example is in
  \href{https://www.datanovia.com/learn/biostatistics/correlation/ggcorrplot-in-r}{ggcorrplot:
  Correlation Matrix Heatmap in R with ggplot2}. }
}
\details{
\code{cor_pmat()} tests each pair of columns with
  \code{\link[stats]{cor.test}}. A pair with fewer than three overlapping
  non-missing observations (which \code{\link[stats]{cor.test}} cannot test,
  e.g. two variables that never co-occur) yields \code{NA} for that cell
  rather than aborting the whole computation. Pairs that can be tested are
  computed as before, and errors they raise are passed through.

  The \code{use} argument controls which pairs are returned as \code{NA} so
  the p-value matrix can be aligned with a correlation matrix built the same
  way. With the default \code{"pairwise.complete.obs"} every pair that has
  enough overlapping observations is tested (the previous behavior). With
  \code{"everything"} a pair is set to \code{NA} whenever either variable has
  any missing value, so the \code{NA} pattern matches
  \code{\link[stats]{cor}(x)} with its default \code{use = "everything"}.
}
\examples{
# Compute a correlation matrix
data(mtcars)
corr <- round(cor(mtcars), 1)
corr

# Compute a matrix of correlation p-values
p.mat <- cor_pmat(mtcars)
p.mat

# Visualize the correlation matrix
# --------------------------------
# method = "square" or "circle"
ggcorrplot(corr)
ggcorrplot(corr, method = "circle")

# Mixed layout: a different glyph per triangle
# --------------------------------
# numbers in the lower triangle, circles in the upper, names on the diagonal
ggcorrplot(corr,
  lower.method = "number", upper.method = "circle",
  show.legend = FALSE
)

# Reordering the correlation matrix
# --------------------------------
# using hierarchical clustering
ggcorrplot(corr, hc.order = TRUE, outline.color = "white")
# draw rectangles around the clusters
ggcorrplot(corr, hc.order = TRUE, hc.rect = 3, outline.color = "white")

# Types of correlogram layout
# --------------------------------
# Get the lower triangle
ggcorrplot(corr,
  hc.order = TRUE, type = "lower",
  outline.color = "white"
)
# Get the upeper triangle
ggcorrplot(corr,
  hc.order = TRUE, type = "upper",
  outline.color = "white"
)

# Change colors and theme
# --------------------------------
# Argument colors
ggcorrplot(corr,
  hc.order = TRUE, type = "lower",
  outline.color = "white",
  ggtheme = ggplot2::theme_gray,
  colors = c("#6D9EC1", "white", "#E46726")
)

# Add correlation coefficients
# --------------------------------
# argument lab = TRUE
ggcorrplot(corr,
  hc.order = TRUE, type = "lower",
  lab = TRUE,
  ggtheme = ggplot2::theme_dark(),
)

# Add correlation significance level
# --------------------------------
# Argument p.mat
# Barring the no significant coefficient
ggcorrplot(corr,
  hc.order = TRUE,
  type = "lower", p.mat = p.mat
)
# Leave blank on no significant coefficient
ggcorrplot(corr,
  p.mat = p.mat, hc.order = TRUE,
  type = "lower", insig = "blank"
)

# Changing number of digits for correlation coeffcient
# --------------------------------
ggcorrplot(cor(mtcars),
  type = "lower",
  insig = "blank",
  lab = TRUE,
  digits = 3
)
}
\seealso{
\href{https://www.datanovia.com/learn/biostatistics/correlation/ggcorrplot-in-r}{ggcorrplot:
  Correlation Matrix Heatmap in R with ggplot2} for worked examples of the
  plot, and
  \href{https://www.datanovia.com/learn/biostatistics/correlation/correlation-matrix-in-r}{Correlation
  Matrix in R: Compute, Visualize & P-values} for computing the matrix and
  its p-values beforehand.

\href{https://www.datanovia.com/learn/biostatistics/correlation/correlation-test-in-r}{Correlation
  Test in R: Pearson, Spearman & Kendall} for the test behind the p-values.
}
